unit UMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, StdActns, ActnList, Menus, Variants,
  ExtCtrls, Grids, Clipbrd;

type
  TMainForm = class(TForm)
{MENU}
    ActionList1: TActionList;
    EditCut1: TEditCut;
    EditCopy1: TEditCopy;
    EditPaste1: TEditPaste;
    EditDelete1: TEditDelete;
    MainMenu1: TMainMenu;
    Edit: TMenuItem;
    Copy: TMenuItem;
    Cut: TMenuItem;
    Paste: TMenuItem;
    Delete: TMenuItem;
{GENERAL}
    PageControl: TPageControl;
    IntroTab: TTabSheet;
    MathTab: TTabSheet;
    InpTab: TTabSheet;
    OutTab: TTabSheet;
    GraphTab: TTabSheet;
{INTRO}
    IntroMemo: TMemo;
{MATH}
    MathMemo: TMemo;
{FIGURE}
    FigTab: TTabSheet;
    FigImage: TImage;
    FigMemo: TMemo;
{INPUT}
{Input general}
    InputOpenDialog: TOpenDialog;
    InputSaveDialog: TSaveDialog;
{Input tab}
    NameLabel: TLabel;
    FileLabel: TLabel;
    InputPanel: TPanel;
    GenPanel: TPanel;
    HydrPanel: TPanel;
    Salt1Panel: TPanel;
    Salt2Panel: TPanel;
    Salt3Panel: TPanel;
    Soil1Panel: TPanel;
    Soil2Panel: TPanel;
    Soil3Panel: TPanel;
    DrainPanel: TPanel;
    CondPanel: TPanel;
    InpLabel: TLabel;
    GenOpenButton: TButton;
    HydrOpenButton: TButton;
    SoilOpenButton: TButton;
    SaltOpenButton: TButton;
    DrainOpenButton: TButton;
    CondOpenButton: TButton;
    OpenInpButton: TButton;
    SaveAllButton: TButton;
    ReStartButton: TButton;
    Image1: TImage;
    ProgressBar1: TProgressBar;
{General panel}
    TmpGenLabel: TLabel;
    NrLabel: TLabel;
    TstComboLabel: TLabel;
    TitLabel: TLabel;
    Tit1Label: TLabel;
    Tit2Label: TLabel;
    GenLabel: TLabel;
    LayersLabel: TLabel;
    NrTstEdit: TEdit;
    TstCombo: TComboBox;
    Tit1Edit: TEdit;
    Tit2Edit: TEdit;
    GenSaveButton: TButton;
    GenQuitButton: TButton;
    LayersCombo: TComboBox;
{Hydr panel}
    TmpHydrLabel: TLabel;
    IrrLabel: TLabel;
    RainLabel: TLabel;
    EvapLabel: TLabel;
    HydrLabel: TLabel;
    CommentLabel: TLabel;
    HydrSaveButton: TButton;
    HydrQuitButton: TButton;
    HydrGrid: TStringGrid;
{Salt1 panel}
    TmpSalt1Label: TLabel;
    Salt1Label: TLabel;
    Root1Label: TLabel;
    Trans1Label: TLabel;
    Aquif1Label: TLabel;
    Salt1InfoLabel: TLabel;
    SaltGrid1: TStringGrid;
    Salt1SaveButton: TButton;
    Salt1QuitButton: TButton;
{Salt2 panel}
    TmpSalt2Label: TLabel;
    Salt2Label: TLabel;
    Root2Label: TLabel;
    Trans2Label: TLabel;
    Aquif2Label: TLabel;
    Salt2InfoLabel: TLabel;
    Root2ALabel: TLabel;
    Root2BLabel: TLabel;
    SaltGrid2: TStringGrid;
    Salt2SaveButton: TButton;
    Salt2QuitButton: TButton;
{Salt3 panel}
    TmpSalt3Label: TLabel;
    Salt3Label: TLabel;
    Root3Label: TLabel;
    Trans3Label: TLabel;
    Aquif3Label: TLabel;
    Salt3InfoLabel: TLabel;
    Root3ALabel: TLabel;
    Root3BLabel: TLabel;
    Root3CLabel: TLabel;
    SaltGrid3: TStringGrid;
    Salt3SaveButton: TButton;
    Salt3QuitButton: TButton;
{Soil1 panel}
    TmpSoil1Label: TLabel;
    Soil1_1stLabel: TLabel;
    Soil1_2ndLabel: TLabel;
    Soil1_3rdLabel: TLabel;
    Soil1TotporLabel: TLabel;
    Soil1EffPorLabel: TLabel;
    Soil1LeachLabel: TLabel;
    Soil1DepthLabel: TLabel;
    Soil1Label: TLabel;
    Soil1InitSaltLabel: TLabel;
    Soil1Grid: TStringGrid;
    Soil1SaveButton: TButton;
    Soil1QuitButton: TButton;
{Soil2 panel}
    TmpSoil2Label: TLabel;
    Soil2_1stLabel: TLabel;
    Soil2_2ndLabel: TLabel;
    Soil2_3rdLabel: TLabel;
    Soil2TotPorLabel: TLabel;
    Soil2EffPorLabel: TLabel;
    Soil2LeachLabel: TLabel;
    Soil2DepthLabel: TLabel;
    Soil2Label: TLabel;
    Soil2Layer2Label: TLabel;
    Soil2Layer1Label: TLabel;
    Soil2InitSaltLabel: TLabel;
    Soil2Grid: TStringGrid;
    Soil2SaveButton: TButton;
    Soil2QuitButton: TButton;
{Soil3 panel}
    TmSoil3Label: TLabel;
    Soil3_1stLabel: TLabel;
    Soil3_2ndLabel: TLabel;
    Soil3_3rdLabel: TLabel;
    Soil3TotPorLabel: TLabel;
    Soil3EffPorLabelLabel: TLabel;
    Soil3LeachLabel: TLabel;
    Soi3lDepthLabel: TLabel;
    Soil3Label: TLabel;
    Soil3Layer2Label: TLabel;
    Soil3Layer1Label1: TLabel;
    Soil3Layer3Label: TLabel;
    Soil3InitSaltLabel: TLabel;
    Soil3Grid: TStringGrid;
    Soil3SaveButton: TButton;
    Soil3QuitButton: TButton;
{Drain panel}
    TmpDrainLabel: TLabel;
    DrainDepthLabel: TLabel;
    DrainQH1Label: TLabel;
    DrainQH2Label: TLabel;
    DrainLabel: TLabel;
    DrainPresentLabel: TLabel;
    DrainQuitButton: TButton;
    DrainSaveButton: TButton;
    DrainHelpButton: TButton;
    DrainPresentCombo: TComboBox;
    DrainDepthEdit: TEdit;
    DrainQH1Edit: TEdit;
    DrainQH2Edit: TEdit;
{Cond panel}
    CondLabel: TLabel;
    SaltIrrigLabel: TLabel;
    GrwtInfLabel: TLabel;
    GrwtOutLabel: TLabel;
    WTdepthLabel: TLabel;
    IrrEffLabel: TLabel;
    CritDepthLabel: TLabel;
    SalInfLabel: TLabel;
    MoistLabel: TLabel;
    SaltIrrigEdit: TEdit;
    GrwtInfEdit: TEdit;
    GrwtOutEdit: TEdit;
    WTdepthEdit: TEdit;
    IrrEffEdit: TEdit;
    SalInfEdit: TEdit;
    MoistEdit: TEdit;
    CritDepthEdit: TEdit;
    CondSaveButton: TButton;
    CondQuitButton: TButton;
{OUTPUT}
    OutputOpenDialog: TOpenDialog;
    HydrOutMemo: TMemo;
    OutputMemo: TMemo;
    OutSalt1Memo: TMemo;
    OutSalt2Memo: TMemo;
    OutSalt3Memo: TMemo;
    OutLabel: TLabel;
    CopyLabel: TLabel;
    ClipLabel: TLabel;
    OutGrid: TStringGrid;
    OpenOutputButton: TButton;
    SaltShowButton: TButton;
    HydrShowButton: TButton;
    GraphButton: TButton;
    ClipButton: TButton;
{GRAPHS}
    GraphSave_Dialog: TSaveDialog;
    GraphOpen_Dialog: TOpenDialog;
    GraphImage: TImage;
    OpenGrapButton: TButton;
    MakeGraphButton: TButton;
    GraphPanel: TPanel;
    GraphRadioGroup: TRadioGroup;
    GraphHydrRadioButton: TRadioButton;
    GraphSaltRadioButton: TRadioButton;
    SurfHydrRadioButton: TRadioButton;
    SubSurfHydrRadioButton: TRadioButton;
    SalFirstRadioButton: TRadioButton;
    SalSecondRadioButton: TRadioButton;
    SalThirdRadioButton: TRadioButton;
    SalBelowRadioButton: TRadioButton;
    GraphGoButton: TButton;
    GraphWTRadioButton: TRadioButton;
    SaveGraphButton: TButton;
    GraphSelectButton: TButton;
{START}
    procedure FormCreate(Sender: TObject);
{Intro}
    procedure MathTabShow(Sender: TObject);
{INPUT}
    procedure InpTabShow(Sender: TObject);
    procedure OpenInpButtonClick(Sender: TObject);
    procedure HandlePasteMultiCell(Sender: TObject; ACol,
                        ARow: Integer; const Value: String);
    function  StringToFloat(Str : string) : double;
    procedure SaveAllButtonClick(Sender: TObject);
    procedure ReStartButtonClick(Sender: TObject);
{InputPanel}
    procedure GenOpenButtonClick(Sender: TObject);
    procedure HydrOpenButtonClick(Sender: TObject);
    procedure SoilOpenButtonClick(Sender: TObject);
    procedure SaltOpenButtonClick(Sender: TObject);
    procedure DrainOpenButtonClick(Sender: TObject);
{GenPanel}
    procedure GenQuitButtonClick(Sender: TObject);
    procedure GenSaveButtonClick(Sender: TObject);
{HydrPanel}
    procedure HydrGridSetEditText(Sender: TObject; ACol, ARow: Integer;
      const Value: String);
    procedure HydrSaveButtonClick(Sender: TObject);
    procedure HydrQuitButtonClick(Sender: TObject);
{Soil Panel 1}
    procedure Soil1QuitButtonClick(Sender: TObject);
    procedure Soil1SaveButtonClick(Sender: TObject);
{Soil Panel 2}
    procedure Soil2QuitButtonClick(Sender: TObject);
    procedure Soil2SaveButtonClick(Sender: TObject);
{Soil Panel 3}
    procedure Soil3SaveButtonClick(Sender: TObject);
    procedure Soil3QuitButtonClick(Sender: TObject);
{Salt Panel 1}
    procedure Salt1QuitButtonClick(Sender: TObject);
    procedure SaltGrid1SetEditText(Sender: TObject; ACol, ARow: Integer;
              const Value: String);
    procedure Salt1SaveButtonClick(Sender: TObject);
{Salt Panel 2}
    procedure Salt2QuitButtonClick(Sender: TObject);
    procedure SaltGrid2SetEditText(Sender: TObject; ACol, ARow: Integer;
              const Value: String);
    procedure Salt2SaveButtonClick(Sender: TObject);
{Salt Panel 3}
    procedure Salt3QuitButtonClick(Sender: TObject);
    procedure SaltGrid3SetEditText(Sender: TObject; ACol, ARow: Integer;
              const Value: String);
    procedure Salt3SaveButtonClick(Sender: TObject);
{DrainPanel}
    procedure DrainPresentComboChange(Sender: TObject);
    procedure DrainSaveButtonClick(Sender: TObject);
    procedure DrainQuitButtonClick(Sender: TObject);
{CondPanel}
    procedure CondOpenButtonClick(Sender: TObject);
    procedure CondQuitButtonClick(Sender: TObject);
    procedure CondSaveButtonClick(Sender: TObject);
    procedure DrainHelpButtonClick(Sender: TObject);
{OUTPUT}
    procedure OpenOutputButtonClick(Sender: TObject);
    procedure SaltShowButtonClick(Sender: TObject);
    procedure HydrShowButtonClick(Sender: TObject);
    procedure ClipButtonClick(Sender: TObject);
{GRAPHICS}
    procedure GraphButtonClick(Sender: TObject);
    procedure MakeGraphButtonClick(Sender: TObject);
    procedure GraphGoButtonClick(Sender: TObject);
    procedure SaveGraphButtonClick(Sender: TObject);
    procedure OpenGrapButtonClick(Sender: TObject);
    procedure GraphSelectButtonClick(Sender: TObject);
{FINISH}
    procedure FormClose(Sender: TObject; var Action: TCloseAction);

  private
    { Private declarations }
    procedure HidePanels;
    procedure DisableButtons;
    procedure EnableButtons;
    procedure ShowHydrGraph;
    procedure ShowWTGraph;
    procedure ShowSaltGraph;
  public
    { Public declarations }
    PrevDrInd : integer;
    FirstLayer, ScndLayer, ThirdLayer, NewVersion : boolean;
  end;


var
  MainForm: TMainForm;

implementation

uses Ucalc, Uclose, Ugraphs, UDrainForm;

{$R *.dfm}

procedure TMainForm.FormCreate(Sender: TObject);
var i : integer;
begin
  InputOpened:=false;
  CalcDone:=false;
  Checked:=true;
  getdir (0,InitDir);
  InputOpenDialog.InitialDir:=InitDir;
  InputSaveDialog.InitialDir:=InitDir;
  OutputOpenDialog.InitialDir:=InitDir;
  HydrGrid.Cells[0,0]:='Serial Nr';
  SaltGrid1.Cells[0,0]:='Serial Nr';
  NrOfdata:=11;
  NrOfSteps:=11;
  HydrGrid.RowCount:=12;
  SaltGrid1.RowCount:=12;
  SaltGrid2.RowCount:=12;
  SaltGrid3.RowCount:=12;
  NrTstEdit.Text:='11';
  TstCombo.ItemIndex:=1;
  LayersCombo.ItemIndex:=0;
  for i:=1 to 3 do
  begin
    HydrGrid.Cells[i,0]:='mm/timestep';
    SaltGrid1.Cells[i,0]:='(dS/m)';
    SaltGrid2.Cells[i,0]:='(dS/m)';
    SaltGrid3.Cells[i,0]:='(dS/m)';
  end;
  SaltGrid2.Cells[4,0]:='dS/m';
  SaltGrid3.Cells[5,0]:='dS/m';
  for i:=1 to 11 do HydrGrid.Cells[0,i]:=inttostr(i);
  for i:=1 to 11 do SaltGrid1.Cells[0,i]:=inttostr(i);
  for i:=1 to 11 do SaltGrid2.Cells[0,i]:=inttostr(i);
  for i:=1 to 11 do SaltGrid3.Cells[0,i]:=inttostr(i);
  for i:=1 to NrOfData do
  begin
     HydrGrid.Cells[1,i]:='';
     HydrGrid.Cells[2,i]:='';
     HydrGrid.Cells[3,i]:='';
     SaltGrid1.Cells[1,i]:='';
     SaltGrid1.Cells[2,i]:='';
     SaltGrid1.Cells[3,i]:='';
     SaltGrid2.Cells[1,i]:='';
     SaltGrid2.Cells[2,i]:='';
     SaltGrid2.Cells[3,i]:='';
     SaltGrid3.Cells[1,i]:='';
     SaltGrid3.Cells[2,i]:='';
     SaltGrid3.Cells[3,i]:='';
  end;
  PrevIndex:=0;
  DrainSystem:=false;
  IntroTab.Show;
  FileLabel.Visible:=false;
  NameLabel.Caption:='';
  HidePanels;
  DecimalSeparator:='.';
  PrevDrInd:=0;
end;


procedure TMainForm.MathTabShow(Sender: TObject);
{var i : integer; }
begin
  InputOpened:=false;
end;

{INPUT}

procedure TMainForm.InpTabShow(Sender: TObject);
begin
  HidePanels;
  GenOpenButton.Enabled:=true;
  if not InputOpened then
  begin
    HydrOpenButton.Enabled:=false;
    SaltOpenButton.Enabled:=false;
    SoilOpenButton.Enabled:=false;
    DrainOpenButton.Enabled:=false;
    CondOpenButton.Enabled:=false;
  end else
  begin
    HydrOpenButton.Enabled:=true;
    SaltOpenButton.Enabled:=true;
    SoilOpenButton.Enabled:=true;
    DrainOpenButton.Enabled:=true;
    CondOpenButton.Enabled:=true;
  end;
end;


procedure TMainForm.OpenInpButtonClick(Sender: TObject);
{------------------------------------------------------}
var NewDir : string;
begin
  if InputOpenDialog.Execute then
  begin
    FileName := InputOpenDialog.Files.Strings[0];
    NewDir := ExtractFilePath(FileName);
    InputOpenDialog.InitialDir:=NewDir;
    InputSaveDialog.InitialDir:=NewDir;
    ReadInput;
    if NewVersion then
    begin
      RestartButtonClick (Sender);
      exit;
    end;
    FileLabel.Visible:=true;
    NameLabel.Caption:=Filename;
    InputOpened:=true;
    HydrOpenButton.Enabled:=true;
    SaltOpenButton.Enabled:=true;
    SoilOpenButton.Enabled:=true;
    DrainOpenButton.Enabled:=true;
    CondOpenButton.Enabled:=true;
  end else
  begin
    ShowMessage('No input file was selected');
    exit;
  end;
  SaveAllButton.Enabled:=true;
  GenQuitButton.Enabled:=true;
  HydrQuitButton.Enabled:=true;
  Salt1QuitButton.Enabled:=true;
  Salt2QuitButton.Enabled:=true;
  Salt3QuitButton.Enabled:=true;
  Soil1QuitButton.Enabled:=true;
  Soil2QuitButton.Enabled:=true;
  Soil3QuitButton.Enabled:=true;
  DrainQuitButton.Enabled:=true;
  CondQuitButton.Enabled:=true;
  HidePanels;
  GenPanel.Visible:=true;
  Result := false;
  CalcDone:=false;
  GraphButton.Enabled:=false;
  SaveGraphButton.Enabled:=false;
  GraphSelectButton.Enabled:=false;
  SaltShowButton.Enabled:=false;
  HydrShowButton.Enabled:=false;
  OutLabel.Visible:=false;
end; {OpenInpButtonClick}
{-----------------------}


procedure TMainForm.HandlePasteMultiCell(Sender: TObject; ACol,
                      ARow: Integer; const Value: String);
{---------------------------------------------------------------}
// only accepts numbers to be pasted into the grid
  var
   i, m, j, Kr, StartCol, StartRow: integer;
   c: char ;

begin
  m := Length(Value);
  (Sender as TStringGrid).Cells[ACol,ARow] := '' ;
  StartCol := ACol ;
  StartRow := Arow;
  i := 1;
  Kr := 2;
//  Kc := 2;
//  Kw := 1;
  while i <= m do begin
  // loop through the characters of the Value string
    c := Value[i];
    j := Integer(c);
    if j = 9 then
    begin // tab: Move to next column
//      if Kw<>0 then Kc:=Kc+1;
      ACol := ACol + 1 ;
      if i < m then // empty the cell if not at end
        (Sender as TStringGrid).Cells[ACol,ARow] := '' ;
    end
    else if j = 13 then
    begin // CR - is followed by LF
         // Move to next row, jump back to startcolumn
      Kr:=Kr+1;
//      Kw:=0;
      ARow := ARow + 1 ;
      ACol := startcol ;
      i := i + 1 ; // skip the LF
      if i < m then // empty the cell it if not at end
        (Sender as TStringGrid).Cells[ACol,ARow] := '' ;
    end
    else // add the character to the string in the cell if a number
    if c in ['.',',','-',#48,#49,#50,#51,#52,#53,#54,#55,#56,#57] then
        (Sender as TStringGrid).Cells[ACol,ARow] :=
          ConCat((Sender as TStringGrid).Cells[ACol,ARow], c);
    i := i + 1 ;
  end;

  if HydrPaste then
  begin
    HydrGrid.ColCount:=4;
    NrOfSteps:=Kr-2;
    NrOfData:=StartRow+NrOfSteps-1;
    HydrGrid.RowCount:=NrOfData+1;
    NrTstEdit.Text:=inttostr(NrOfData);
    for i:=1 to NrOfData do HydrGrid.Cells[0,i]:=inttostr(i);
    exit;
  end;
  if OneLayer then
  begin
    if Kr>NrOfData+2 then
    begin
      showmessage ('The number of time steps is larger than that given'+
                   ' under Hydrological data. It will be reduced.');
      NrOfSteps:=NrOfData;
    end;
    if Kr<NrOfData+2 then
    begin
      showmessage ('The number of time steps is smaller than that given'+
                   ' under Hydrological data. Missing data must be added');
      NrOfSteps:=NrOfData;
    end;
    SaltGrid1.RowCount:=NrOfSteps+1;
    for i:=1 to NrOfData do SaltGrid1.Cells[0,i]:=inttostr(i);
  end;
  if TwoLayer then
  begin
    if Kr>NrOfData+2 then
    begin
      showmessage ('The number of time steps is larger than that given'+
                   ' under Hydrological data. It will be reduced.');
      NrOfSteps:=NrOfData;
    end;
    if Kr<NrOfData+2 then
    begin
      showmessage ('The number of time steps is smaller than that given'+
                   ' under Hydrological data. Missing data must be added');
      NrOfSteps:=NrOfData;
    end;
    SaltGrid2.RowCount:=NrOfSteps+1;
    for i:=1 to NrOfData do SaltGrid2.Cells[0,i]:=inttostr(i);
  end;
  if ThreeLayer then
  begin
    if Kr>NrOfSteps+2 then
       showmessage ('The number of time steps is larger than that given'+
                    ' under Hydrological data. It will be reduced.');
    if Kr<NrOfData+2 then
      showmessage ('The number of time steps is smaller than that given'+
                   ' under Hydrological data. Missing data must be added');
    NrOfSteps:=NrOfData;
    SaltGrid3.RowCount:=NrOfSteps+1;
    for i:=1 to NrOfData do SaltGrid3.Cells[0,i]:=inttostr(i);
  end;
end; {TForm1.HandlePasteMultiCell}
{--------------------------------}


function TMainForm.StringToFloat(Str : string) : double;
{accepts comma or point for decimal separator}
begin
  try
    Result := StrToFloat(Str);
  except
    on EConvertError do
    begin
      if DecimalSeparator = ',' then
         DecimalSeparator := '.';
      Result := StrToFloat(Str);
    end;
  end;
end; {TMainForm.StringToFloat}


procedure TMainForm.ReStartButtonClick(Sender: TObject);
begin
  FormCreate (Sender);
end;


procedure TMainForm.SaveAllButtonClick(Sender: TObject);
var NewDir : string;
begin
  showmessage ('For saving please create an input data file');
  if SaveAllButton.Enabled or InputOpened then
  begin
      Result := false;
      if InputSaveDialog.Execute then
      begin
        FileName := InputSaveDialog.Files.Strings[0];
        if FileExists(FileName) then
           Result := Question('The file already exists, overwrite?')
        else Result := true;
      end else
      begin
        ShowMessage('No input file was selected');
        exit;
      end;
      NewDir := ExtractFilePath(FileName);
      InputOpenDialog.InitialDir:=NewDir;
      InputSaveDialog.InitialDir:=NewDir;
      SaveData;
      Result := Question('The data were saved as '+Filename+'. Do you wish to'+
                         ' do the calculations?');
      if Result then
      begin
        if NrOfSteps>50 then
        begin
          ProgressBar1.Visible:=true;
          ProgressBar1.Min:=0;
          ProgressBar1.Max:=10;
          ProgressBar1.Position:=1;
          sleep(100);
        end;
        if TstCombo.ItemIndex=0 then StepLength:=360
        else if TstCombo.ItemIndex=1 then StepLength:=30
        else if TstCombo.ItemIndex=2 then  StepLength:=7
        else if TstCombo.ItemIndex=3 then StepLength:=1;
        Calculations;
        if not Checked then exit;
        if TooDeep then exit;
      end else
      begin
        showmessage ('The calculations were not made.');
        exit;
      end;
      showmessage ('The calculations were made. The output can be inspected.');
      CalcDone:=true;
      WriteOutput;
      OutTab.Show;
      GraphButton.Enabled:=true;
      OutLabel.Visible:=true;
      SaltShowButton.Visible:=true;
      HydrShowButton.Visible:=true;
      OutGrid.Visible:=false;
      CopyLabel.Visible:=false;
      HydrOutMemo.Visible:=false;
      OutSalt1Memo.Visible:=false;
      OutSalt2Memo.Visible:=false;
      OutSalt3Memo.Visible:=false;
      SaltShowButton.Enabled:=true;
      HydrShowButton.Enabled:=true;
      CopyLabel.Visible:=false;
      ProgressBar1.Visible:=false;
      ClipLabel.Visible:=false;
      ClipButton.Visible:=false;
  end;

  if not InputOpened and not SaveAllButton.Enabled then
     showmessage ('Not all the input groups were checked. LeachMod cannot'+
                  ' continue');
end; {TMainForm.SaveAllButtonClick}


procedure TMainForm.GenOpenButtonClick(Sender: TObject);
begin
  HidePanels;
  GenPanel.Visible:=true;
  DisableButtons;
end;


procedure TMainForm.HydrOpenButtonClick(Sender: TObject);
begin
  HidePanels;
  HydrPanel.Visible:=true;
  DisableButtons;
end;


procedure TMainForm.SoilOpenButtonClick(Sender: TObject);
begin
  HidePanels;
  if OneLayer then Soil1Panel.Visible:=true;
  if TwoLayer then Soil2Panel.Visible:=true;
  if ThreeLayer then Soil3Panel.Visible:=true;
  DisableButtons;
end;


procedure TMainForm.SaltOpenButtonClick(Sender: TObject);
begin
  HidePanels;
  if OneLayer then Salt1Panel.Visible:=true;
  if TwoLayer then Salt2Panel.Visible:=true;
  if ThreeLayer then Salt3Panel.Visible:=true;
  DisableButtons;
end;


procedure TMainForm.DrainOpenButtonClick(Sender: TObject);
begin
  HidePanels;
  DrainPanel.Visible:=true;
  DisableButtons;
end;


procedure TMainForm.CondOpenButtonClick(Sender: TObject);
begin
  HidePanels;
  CondPanel.Visible:=true;
  DisableButtons;
end;


procedure TMainForm.HidePanels;
begin
  GenPanel.Visible:=false;
  HydrPanel.Visible:=false;
  Salt1Panel.Visible:=false;
  Salt2Panel.Visible:=false;
  Salt3Panel.Visible:=false;
  Soil1Panel.Visible:=false;
  Soil2Panel.Visible:=false;
  Soil3Panel.Visible:=false;
  DrainPanel.Visible:=false;
  CondPanel.Visible:=false;
end;


procedure TMainForm.DisableButtons;
begin
  SaveAllButton.Enabled:=false;
  GenOpenButton.Enabled:=false;
  HydrOpenButton.Enabled:=false;
  SoilOpenButton.Enabled:=false;
  SaltOpenButton.Enabled:=false;
  DrainOpenButton.Enabled:=false;
  CondOpenButton.Enabled:=false;
end;


procedure TMainForm.EnableButtons;
begin
  SaveAllButton.Enabled:=true;
  GenOpenButton.Enabled:=true;
  HydrOpenButton.Enabled:=true;
  SoilOpenButton.Enabled:=true;
  SaltOpenButton.Enabled:=true;
  DrainOpenButton.Enabled:=true;
  CondOpenButton.Enabled:=true;
end;

//General Panel

procedure TMainForm.GenQuitButtonClick(Sender: TObject);
begin
  LayersCombo.ItemIndex:=PrevIndex;
  GenPanel.Visible:=false;
  if InputOpened then EnableButtons
     else DisableButtons;
  GenOpenButton.Enabled:=true;
end;


procedure TMainForm.GenSaveButtonClick(Sender: TObject);
var i : integer;
begin
  Title1:=Tit1Edit.Text;
  Title2:=Tit2Edit.Text;
  NrOfSteps:=strtoint(NrTstEdit.Text);
  NrOfData:=NrOfSteps;
  if TstCombo.ItemIndex=0 then
  StepLength:=360
  else
  if TstCombo.ItemIndex=1 then
  StepLength:=30
  else
//  if TstCombo.ItemIndex=2 then
//  StepLength:=10
//  else
  if TstCombo.ItemIndex=2 then
  StepLength:=7;
  if TstCombo.ItemIndex=3 then
  StepLength:=1;
  OneLayer:=false;
  TwoLayer:=false;
  ThreeLayer:=false;
  if LayersCombo.ItemIndex=0 then OneLayer:=true;
  if LayersCombo.ItemIndex=1 then TwoLayer:=true;
  if LayersCombo.ItemIndex=2 then ThreeLayer:=true;
  NrOfLayers:=LayersCombo.ItemIndex+1;

//Setting values of soil properties upon LayersCombo change
  if (PrevIndex=0) and (LayersCombo.ItemIndex=1) then
  begin
    Soil1Panel.Visible:=false;
    Soil2Grid.Cells[0,0]:=Soil1Grid.Cells[0,0];
    Soil2Grid.Cells[0,1]:=Soil1Grid.Cells[0,0];
    Soil2Grid.Cells[0,2]:=Soil1Grid.Cells[0,1];
    Soil2Grid.Cells[0,3]:=Soil1Grid.Cells[0,2];
    Soil2Grid.Cells[1,0]:=Soil1Grid.Cells[1,0];
    Soil2Grid.Cells[1,1]:=Soil1Grid.Cells[1,0];
    Soil2Grid.Cells[1,2]:=Soil1Grid.Cells[1,1];
    Soil2Grid.Cells[1,3]:=Soil1Grid.Cells[1,2];
    Soil2Grid.Cells[2,0]:=Soil1Grid.Cells[2,0];
    Soil2Grid.Cells[2,1]:=Soil1Grid.Cells[2,0];
    Soil2Grid.Cells[2,2]:=Soil1Grid.Cells[2,1];
    Soil2Grid.Cells[2,3]:=Soil1Grid.Cells[2,2];
    Soil2Grid.Cells[3,0]:=Soil1Grid.Cells[3,0];
    Soil2Grid.Cells[3,1]:=Soil1Grid.Cells[3,0];
    Soil2Grid.Cells[3,2]:=Soil1Grid.Cells[3,1];
    Soil2Grid.Cells[3,3]:=Soil1Grid.Cells[3,2];
    Soil2Grid.Cells[4,0]:=Soil1Grid.Cells[4,0];
    Soil2Grid.Cells[4,1]:=Soil1Grid.Cells[4,0];
    Soil2Grid.Cells[4,2]:=Soil1Grid.Cells[4,1];
    Soil2Grid.Cells[4,3]:=Soil1Grid.Cells[4,2];
  end;
  if (PrevIndex=0) and (LayersCombo.ItemIndex=2) then
  begin
    Soil1Panel.Visible:=false;
    Soil3Grid.Cells[0,0]:=Soil1Grid.Cells[0,0];
    Soil3Grid.Cells[0,1]:=Soil1Grid.Cells[0,0];
    Soil3Grid.Cells[0,2]:=Soil1Grid.Cells[0,0];
    Soil3Grid.Cells[0,3]:=Soil1Grid.Cells[0,3];
    Soil3Grid.Cells[0,4]:=Soil1Grid.Cells[0,4];
    Soil3Grid.Cells[1,0]:=Soil1Grid.Cells[1,0];
    Soil3Grid.Cells[1,1]:=Soil1Grid.Cells[1,0];
    Soil3Grid.Cells[1,2]:=Soil1Grid.Cells[1,0];
    Soil3Grid.Cells[1,3]:=Soil1Grid.Cells[1,3];
    Soil3Grid.Cells[1,4]:=Soil1Grid.Cells[1,4];
    Soil3Grid.Cells[2,0]:=Soil1Grid.Cells[2,0];
    Soil3Grid.Cells[2,1]:=Soil1Grid.Cells[2,0];
    Soil3Grid.Cells[2,2]:=Soil1Grid.Cells[2,0];
    Soil3Grid.Cells[2,3]:=Soil1Grid.Cells[2,3];
    Soil3Grid.Cells[2,4]:=Soil1Grid.Cells[2,4];
    Soil3Grid.Cells[3,0]:=Soil1Grid.Cells[3,0];
    Soil3Grid.Cells[3,1]:=Soil1Grid.Cells[3,0];
    Soil3Grid.Cells[3,2]:=Soil1Grid.Cells[3,0];
    Soil3Grid.Cells[3,3]:=Soil1Grid.Cells[3,3];
    Soil3Grid.Cells[3,4]:=Soil1Grid.Cells[3,4];
    Soil3Grid.Cells[4,1]:=Soil1Grid.Cells[4,0];
    Soil3Grid.Cells[4,2]:=Soil1Grid.Cells[4,0];
    Soil3Grid.Cells[4,3]:=Soil1Grid.Cells[4,3];
    Soil3Grid.Cells[4,4]:=Soil1Grid.Cells[4,4];
  end;
  if (PrevIndex=1) and (LayersCombo.ItemIndex=0) then
  begin
    Soil2Panel.Visible:=false;
    Soil1Grid.Cells[0,0]:=Soil2Grid.Cells[0,0];
    Soil1Grid.Cells[0,1]:=Soil2Grid.Cells[0,2];
    Soil1Grid.Cells[0,2]:=Soil2Grid.Cells[0,3];
    Soil1Grid.Cells[1,0]:=Soil2Grid.Cells[1,0];
    Soil1Grid.Cells[1,1]:=Soil2Grid.Cells[1,2];
    Soil1Grid.Cells[1,2]:=Soil2Grid.Cells[1,3];
    Soil1Grid.Cells[2,0]:=Soil2Grid.Cells[2,0];
    Soil1Grid.Cells[2,1]:=Soil2Grid.Cells[2,2];
    Soil1Grid.Cells[2,2]:=Soil2Grid.Cells[2,3];
    Soil1Grid.Cells[3,0]:=Soil2Grid.Cells[3,0];
    Soil1Grid.Cells[3,1]:=Soil2Grid.Cells[3,2];
    Soil1Grid.Cells[3,2]:=Soil2Grid.Cells[3,3];
    Soil1Grid.Cells[4,0]:=Soil2Grid.Cells[3,0];
    Soil1Grid.Cells[4,1]:=Soil2Grid.Cells[3,2];
    Soil1Grid.Cells[4,2]:=Soil2Grid.Cells[3,3];
  end;
  if (PrevIndex=1) and (LayersCombo.ItemIndex=2) then
  begin
    Soil2Panel.Visible:=false;
    Soil3Grid.Cells[0,0]:=Soil2Grid.Cells[0,0];
    Soil3Grid.Cells[0,1]:=Soil2Grid.Cells[0,0];
    Soil3Grid.Cells[0,2]:=Soil2Grid.Cells[0,1];
    Soil3Grid.Cells[0,3]:=Soil2Grid.Cells[0,2];
    Soil3Grid.Cells[0,4]:=Soil2Grid.Cells[0,3];
    Soil3Grid.Cells[1,0]:=Soil2Grid.Cells[1,0];
    Soil3Grid.Cells[1,1]:=Soil2Grid.Cells[1,0];
    Soil3Grid.Cells[1,2]:=Soil2Grid.Cells[1,1];
    Soil3Grid.Cells[1,3]:=Soil2Grid.Cells[1,2];
    Soil3Grid.Cells[1,4]:=Soil2Grid.Cells[1,3];
    Soil3Grid.Cells[2,0]:=Soil2Grid.Cells[2,0];
    Soil3Grid.Cells[2,1]:=Soil2Grid.Cells[2,0];
    Soil3Grid.Cells[2,2]:=Soil2Grid.Cells[2,1];
    Soil3Grid.Cells[2,3]:=Soil2Grid.Cells[2,2];
    Soil3Grid.Cells[2,4]:=Soil2Grid.Cells[2,3];
    Soil3Grid.Cells[3,0]:=Soil2Grid.Cells[3,0];
    Soil3Grid.Cells[3,1]:=Soil2Grid.Cells[3,0];
    Soil3Grid.Cells[3,2]:=Soil2Grid.Cells[3,1];
    Soil3Grid.Cells[3,3]:=Soil2Grid.Cells[3,2];
    Soil3Grid.Cells[3,4]:=Soil2Grid.Cells[3,3];
    Soil3Grid.Cells[4,1]:=Soil2Grid.Cells[4,0];
    Soil3Grid.Cells[4,2]:=Soil2Grid.Cells[4,1];
    Soil3Grid.Cells[4,3]:=Soil2Grid.Cells[4,2];
    Soil3Grid.Cells[4,4]:=Soil2Grid.Cells[4,3];
  end;
  if (PrevIndex=2) and (LayersCombo.ItemIndex=0) then
  begin
    Soil3Panel.Visible:=false;
    Soil1Grid.Cells[0,0]:=Soil3Grid.Cells[0,0];
    Soil1Grid.Cells[0,1]:=Soil3Grid.Cells[0,3];
    Soil1Grid.Cells[0,2]:=Soil3Grid.Cells[0,4];
    Soil1Grid.Cells[1,0]:=Soil3Grid.Cells[1,0];
    Soil1Grid.Cells[1,1]:=Soil3Grid.Cells[1,3];
    Soil1Grid.Cells[1,2]:=Soil3Grid.Cells[1,4];
    Soil1Grid.Cells[2,0]:=Soil3Grid.Cells[2,0];
    Soil1Grid.Cells[2,1]:=Soil3Grid.Cells[2,3];
    Soil1Grid.Cells[2,2]:=Soil3Grid.Cells[2,4];
    Soil1Grid.Cells[3,0]:=Soil3Grid.Cells[3,0];
    Soil1Grid.Cells[3,1]:=Soil3Grid.Cells[3,3];
    Soil1Grid.Cells[3,2]:=Soil3Grid.Cells[3,4];
    Soil1Grid.Cells[4,0]:=Soil3Grid.Cells[4,0];
    Soil1Grid.Cells[4,1]:=Soil3Grid.Cells[4,3];
    Soil1Grid.Cells[4,2]:=Soil3Grid.Cells[4,4];
  end;
  if (PrevIndex=2) and (LayersCombo.ItemIndex=1) then
  begin
    Soil3Panel.Visible:=false;
    Soil2Grid.Cells[0,0]:=Soil3Grid.Cells[0,0];
    Soil2Grid.Cells[0,1]:=Soil3Grid.Cells[0,1];
    Soil2Grid.Cells[0,2]:=Soil3Grid.Cells[0,3];
    Soil2Grid.Cells[0,3]:=Soil3Grid.Cells[0,4];
    Soil2Grid.Cells[1,0]:=Soil3Grid.Cells[1,0];
    Soil2Grid.Cells[1,1]:=Soil3Grid.Cells[1,1];
    Soil2Grid.Cells[1,2]:=Soil3Grid.Cells[1,3];
    Soil2Grid.Cells[1,3]:=Soil3Grid.Cells[1,4];
    Soil2Grid.Cells[2,0]:=Soil3Grid.Cells[2,0];
    Soil2Grid.Cells[2,1]:=Soil3Grid.Cells[2,1];
    Soil2Grid.Cells[2,2]:=Soil3Grid.Cells[2,3];
    Soil2Grid.Cells[2,3]:=Soil3Grid.Cells[2,4];
    Soil2Grid.Cells[3,0]:=Soil3Grid.Cells[3,0];
    Soil2Grid.Cells[3,1]:=Soil3Grid.Cells[3,1];
    Soil2Grid.Cells[3,2]:=Soil3Grid.Cells[3,3];
    Soil2Grid.Cells[3,3]:=Soil3Grid.Cells[3,4];
    Soil2Grid.Cells[4,0]:=Soil3Grid.Cells[4,0];
    Soil2Grid.Cells[4,1]:=Soil3Grid.Cells[4,1];
    Soil2Grid.Cells[4,2]:=Soil3Grid.Cells[4,3];
    Soil2Grid.Cells[4,3]:=Soil3Grid.Cells[4,4];
  end;
  if PrevIndex<LayersCombo.ItemIndex then
  begin
    showmessage ('The number of layers was increased and data must be added.'+
    ' Please check and save each data group before using "Save All"');
    InputOpened:=false;
  end else
    if PrevIndex>LayersCombo.ItemIndex then
    begin
       showmessage ('The number of layers was reduced.'+
       ' Please check and save each data group before using "Save All"');
      InputOpened:=false;
    end;

  if not InputOpened then
  begin
  GenQuitButton.Enabled:=false;
  HydrQuitButton.Enabled:=false;
  Salt1QuitButton.Enabled:=false;
  Salt2QuitButton.Enabled:=false;
  Salt3QuitButton.Enabled:=false;
  Soil1QuitButton.Enabled:=false;
  Soil2QuitButton.Enabled:=false;
  Soil3QuitButton.Enabled:=false;
  DrainQuitButton.Enabled:=false;
  CondQuitButton.Enabled:=false;
  end;

//Setting measured salinity values upon LayerCombo change
  if (PrevIndex=0) and (LayersCombo.ItemIndex=1) then
  begin
    SaltGrid2.RowCount:=NrofSteps+1;
    for i:=1 to NrOfSteps do
    begin
      SaltGrid2.Cells[1,i]:=SaltGrid1.Cells[1,i];
      SaltGrid2.Cells[2,i]:=SaltGrid1.Cells[1,i];
      SaltGrid2.Cells[3,i]:=SaltGrid1.Cells[2,i];
      SaltGrid2.Cells[4,i]:=SaltGrid1.Cells[3,i];
    end;
  end;
  if (PrevIndex=0) and (LayersCombo.ItemIndex=2) then
  begin
    SaltGrid3.RowCount:=NrofSteps+1;
    for i:=1 to NrOfSteps do
    begin
      SaltGrid3.Cells[1,i]:=SaltGrid1.Cells[1,i];
      SaltGrid3.Cells[2,i]:=SaltGrid1.Cells[1,i];
      SaltGrid3.Cells[3,i]:=SaltGrid1.Cells[1,i];
      SaltGrid3.Cells[4,i]:=SaltGrid1.Cells[2,i];
      SaltGrid3.Cells[5,i]:=SaltGrid1.Cells[3,i];
    end;
  end;
  if (PrevIndex=1) and (LayersCombo.ItemIndex=0) then
  begin
    SaltGrid1.RowCount:=NrofSteps+1;
    for i:=1 to NrOfSteps do
    begin
      SaltGrid1.Cells[1,i]:=SaltGrid2.Cells[1,i];
      SaltGrid1.Cells[2,i]:=SaltGrid2.Cells[3,i];
      SaltGrid1.Cells[3,i]:=SaltGrid2.Cells[4,i];
    end;
  end;
  if (PrevIndex=1) and (LayersCombo.ItemIndex=2) then
  begin
    SaltGrid3.RowCount:=NrofSteps+1;
    for i:=1 to NrOfSteps do
    begin
      SaltGrid3.Cells[1,i]:=SaltGrid2.Cells[1,i];
      SaltGrid3.Cells[2,i]:=SaltGrid2.Cells[1,i];
      SaltGrid3.Cells[3,i]:=SaltGrid2.Cells[2,i];
      SaltGrid3.Cells[4,i]:=SaltGrid2.Cells[3,i];
      SaltGrid3.Cells[5,i]:=SaltGrid2.Cells[4,i];
    end;
  end;
  if (PrevIndex=2) and (LayersCombo.ItemIndex=0) then
  begin
    SaltGrid1.RowCount:=NrofSteps+1;
    SaltGrid1.ColCount:=4;
    for i:=1 to NrOfSteps do
    begin
      SaltGrid1.Cells[1,i]:=SaltGrid3.Cells[1,i];
      SaltGrid1.Cells[2,i]:=SaltGrid3.Cells[4,i];
      SaltGrid1.Cells[3,i]:=SaltGrid3.Cells[5,i];
    end;
  end;
  if (PrevIndex=2) and (LayersCombo.ItemIndex=1) then
  begin
    SaltGrid2.RowCount:=NrofSteps+1;
    for i:=1 to NrOfSteps do
    begin
      SaltGrid2.Cells[1,i]:=SaltGrid3.Cells[1,i];
      SaltGrid2.Cells[2,i]:=SaltGrid3.Cells[2,i];
      SaltGrid2.Cells[3,i]:=SaltGrid3.Cells[4,i];
      SaltGrid2.Cells[4,i]:=SaltGrid3.Cells[5,i];
    end;
  end;

  HydrGrid.RowCount:=NrOfSteps+1;
  SaltGrid1.RowCount:=NrOfSteps+1;
  SaltGrid2.RowCount:=NrOfSteps+1;
  SaltGrid3.RowCount:=NrOfSteps+1;
  for i:=1 to NrOfSteps do
  begin
    HydrGrid.Cells[0,i]:=inttostr(i);
    SaltGrid1.Cells[0,i]:=inttostr(i);
    SaltGrid2.Cells[0,i]:=inttostr(i);
    SaltGrid3.Cells[0,i]:=inttostr(i);
  end;
  if InputOpened then
    showmessage ('The general data were saved.')
  else
    showmessage ('The general data were saved.'+
                 ' Continue with the hydrological data.');
  PrevIndex:=LayersCombo.ItemIndex;
  GenPanel.Visible:=false;
  if InputOpened then EnableButtons
     else DisableButtons;
  GenQuitButton.Enabled:=true;
  HydrOpenButton.Enabled:=true;
  HydrPanel.Visible:=true;
end; {TMainForm.GenSaveButtonClick}

//Hydrological Panel

procedure TMainForm.HydrGridSetEditText(Sender: TObject; ACol, ARow: Integer;
  const Value: String);
var MultiPaste:boolean;
    i : integer;
begin
  HydrPaste:=true;
  MultiPaste := (POS(FORMAT('%s',[#9]), Value)> 0 );
  MultiPaste := MultiPaste or (POS(FORMAT('%s',[#13]), Value)> 0 );
  if MultiPaste then
  begin
    Try
      HandlePasteMultiCell(Sender, ACol, ARow, Value) ;
      Except on E: Exception do
      begin
        Showmessage ('There are not enough data to be pasted or the data'+
                     ' are incompatible');
        exit;
      end;
    end;
  end;
  for i:=1 to NrOfSteps do
  begin
    SaltGrid1.Cells[0,i]:=inttostr(i);
    SaltGrid2.Cells[0,i]:=inttostr(i);
    SaltGrid3.Cells[0,i]:=inttostr(i);
  end;
end;


procedure TMainForm.HydrSaveButtonClick(Sender: TObject);
var i : integer;
begin
  setlength (Rain,NrOfData+1);
  setlength (Irri,NrOfData+1);
  setlength (Evap,NrOfData+1);
  for i:=1 to NrOfData do
  begin
     if (HydrGrid.Cells[1,i]='') or (HydrGrid.Cells[2,i]='') or
        (HydrGrid.Cells[3,i]='') then
     begin
        Showmessage ('There are empty cells, please correct.');
        exit;
     end;
     Rain[i]:=stringtofloat(HydrGrid.Cells[1,i]);
     Irri[i]:=stringtofloat(HydrGrid.Cells[2,i]);
     Evap[i]:=stringtofloat(HydrGrid.Cells[3,i]);
  end;
  if InputOpened then
    showmessage ('The hydrological data were saved.')
  else
    showmessage ('The hydrological data were saved.'+
                 ' Continue with the Soil properties.');
  if InputOpened then SaveAllButton.Enabled:=true;
  if InputOpened then EnableButtons
     else DisableButtons;
  HydrQuitButton.Enabled:=true;
  SoilOpenButton.Enabled:=true;
  HidePanels;
  HydrGrid.RowCount:=NrOfData+1;
  SaltGrid1.RowCount:=NrOfData+1;
  SaltGrid2.RowCount:=NrOfData+1;
  SaltGrid3.RowCount:=NrOfData+1;
  if OneLayer then Soil1Panel.Visible:=true;
  if TwoLayer then Soil2Panel.Visible:=true;
  if ThreeLayer then Soil3Panel.Visible:=true;
  for i:=1 to NrOfData do SaltGrid1.Cells[0,i]:=inttostr(i);
  for i:=1 to NrOfData do SaltGrid2.Cells[0,i]:=inttostr(i);
  for i:=1 to NrOfData do SaltGrid3.Cells[0,i]:=inttostr(i);
end; {HydrSaveButtonClick}


procedure TMainForm.HydrQuitButtonClick(Sender: TObject);
begin
  HydrPanel.Visible:=false;
  if InputOpened then EnableButtons
     else DisableButtons;
  HydrOpenButton.Enabled:=true;
 end;

//Soil1 Panel

procedure TMainForm.Soil1QuitButtonClick(Sender: TObject);
begin
  Soil1Panel.Visible:=false;
  if InputOpened then EnableButtons
     else DisableButtons;
  SoilOpenButton.Enabled:=true;
end;


procedure TMainForm.Soil1SaveButtonClick(Sender: TObject);
var CheckValue:integer;
begin
  CheckValue:=0;
  if Soil1Grid.Cells[0,0]='' then CheckValue:=-1
  else Layer1:=stringtofloat(Soil1Grid.Cells[0,0]);
  if Soil1Grid.Cells[0,1]='' then CheckValue:=-1
  else Trans:=stringtofloat(Soil1Grid.Cells[0,1]);
  if Soil1Grid.Cells[0,2]='' then CheckValue:=-1
  else Aquif:=stringtofloat(Soil1Grid.Cells[0,2]);
  if Soil1Grid.Cells[1,0]='' then CheckValue:=-1
  else TotPor1:=stringtofloat(Soil1Grid.Cells[1,0]);
  if Soil1Grid.Cells[1,1]='' then CheckValue:=-1
  else TotPorTR:=stringtofloat(Soil1Grid.Cells[1,1]);
  if Soil1Grid.Cells[1,2]='' then CheckValue:=-1
  else TotPorAQ:=stringtofloat(Soil1Grid.Cells[1,2]);
  if Soil1Grid.Cells[2,0]='' then CheckValue:=-1
  else EffPor1:=stringtofloat(Soil1Grid.Cells[2,0]);
  if Soil1Grid.Cells[2,1]='' then CheckValue:=-1
  else EffPorTR:=stringtofloat(Soil1Grid.Cells[2,1]);
  if Soil1Grid.Cells[2,2]='' then CheckValue:=-1
  else EffPorAQ:=stringtofloat(Soil1Grid.Cells[2,2]);
  if Soil1Grid.Cells[3,0]='' then CheckValue:=-1
  else LeachEff1:=stringtofloat(Soil1Grid.Cells[3,0]);
  if Soil1Grid.Cells[3,1]='' then CheckValue:=-1
  else LeachEffTR:=stringtofloat(Soil1Grid.Cells[3,1]);
  if Soil1Grid.Cells[3,2]='' then CheckValue:=-1
  else LeachEffAQ:=stringtofloat(Soil1Grid.Cells[3,2]);
  if CheckValue<0 then
  begin
    showmessage ('There are invalid values. Please adjust.');
    exit;
  end;
  if InputOpened then
    showmessage ('The data on Soil properties were saved.')
  else
    showmessage ('The salinity data were saved.'+
                 ' Continue with the data on the Subsurface Drainage system.');
  RootZone:=Layer1;
  Soil1Panel.Visible:=false;
  if InputOpened then EnableButtons
     else DisableButtons;
  Soil1QuitButton.Enabled:=true;
  Salt1Panel.Visible:=true;
  SaltOpenButton.Enabled:=true;
end;

//Soil2 Panel

procedure TMainForm.Soil2QuitButtonClick(Sender: TObject);
begin
  Soil2Panel.Visible:=false;
  if InputOpened then EnableButtons
     else DisableButtons;
  SoilOpenButton.Enabled:=true;
end;


procedure TMainForm.Soil2SaveButtonClick(Sender: TObject);
var CheckValue:integer;
begin
  CheckValue:=0;
  if Soil2Grid.Cells[0,0]='' then CheckValue:=-1
  else Layer1:=stringtofloat(Soil2Grid.Cells[0,0]);
  if Soil2Grid.Cells[0,1]='' then CheckValue:=-1
  else Layer2:=stringtofloat(Soil2Grid.Cells[0,1]);
  if Soil2Grid.Cells[0,2]='' then CheckValue:=-1
  else Trans:=stringtofloat(Soil2Grid.Cells[0,2]);
  if Soil2Grid.Cells[0,3]='' then CheckValue:=-1
  else Aquif:=stringtofloat(Soil2Grid.Cells[0,3]);
  if Soil2Grid.Cells[1,0]='' then CheckValue:=-1
  else TotPor1:=stringtofloat(Soil2Grid.Cells[1,0]);
  if Soil2Grid.Cells[1,1]='' then CheckValue:=-1
  else TotPor2:=stringtofloat(Soil2Grid.Cells[1,1]);
  if Soil2Grid.Cells[1,2]='' then CheckValue:=-1
  else TotPorTR:=stringtofloat(Soil2Grid.Cells[1,2]);
  if Soil2Grid.Cells[1,3]='' then CheckValue:=-1
  else TotPorAQ:=stringtofloat(Soil2Grid.Cells[1,3]);
  if Soil2Grid.Cells[2,0]='' then CheckValue:=-1
  else EffPor1:=stringtofloat(Soil2Grid.Cells[2,0]);
  if Soil2Grid.Cells[2,1]='' then CheckValue:=-1
  else EffPor2:=stringtofloat(Soil2Grid.Cells[2,1]);
  if Soil2Grid.Cells[2,2]='' then CheckValue:=-1
  else EffPorTR:=stringtofloat(Soil2Grid.Cells[2,2]);
  if Soil2Grid.Cells[2,3]='' then CheckValue:=-1
  else EffPorAQ:=stringtofloat(Soil2Grid.Cells[2,3]);
  if Soil2Grid.Cells[3,0]='' then CheckValue:=-1
  else LeachEff1:=stringtofloat(Soil2Grid.Cells[3,0]);
  if Soil2Grid.Cells[3,1]='' then LeachEff2:=-1
  else LeachEff2:=stringtofloat(Soil2Grid.Cells[3,1]);
  if Soil2Grid.Cells[3,2]='' then CheckValue:=-1
  else LeachEffTR:=stringtofloat(Soil2Grid.Cells[3,2]);
  if Soil2Grid.Cells[3,3]='' then CheckValue:=-1
  else LeachEffAQ:=stringtofloat(Soil2Grid.Cells[3,3]);
  if CheckValue<0 then
  begin
    showmessage ('There are invalid values. Please adjust.');
    exit;
  end;
  if InputOpened then
    showmessage ('The soil data were saved.')
  else
    showmessage ('The soil data were saved.'+
                 ' Continue with the Salinity data ..');
  if InputOpened then SaveAllButton.Enabled:=true;
  RootZone:=Layer1+Layer2;
  Soil2Panel.Visible:=false;
  if InputOpened then EnableButtons
     else DisableButtons;
  SaltOpenButton.Enabled:=true;
  Soil2QuitButton.Enabled:=true;
  Salt2Panel.Visible:=true;
  if not InputOpened then DrainQuitButton.Enabled:=false;
end;

//Soil3 Panel

procedure TMainForm.Soil3QuitButtonClick(Sender: TObject);
begin
  Soil3Panel.Visible:=false;
  if InputOpened then EnableButtons
     else DisableButtons;
  Salt3QuitButton.Enabled:=true;
  Soil1QuitButton.Enabled:=true;             {necessay ???}
  Soil2QuitButton.Enabled:=true;             {necessay ???}
  SoilOpenButton.Enabled:=true;
end;


procedure TMainForm.Soil3SaveButtonClick(Sender: TObject);
//var CheckValue:integer;
begin
  if Soil3Grid.Cells[0,0]='' then Layer1:=-1
  else Layer1:=stringtofloat(Soil3Grid.Cells[0,0]);
  if Soil3Grid.Cells[0,1]='' then Layer2:=-1
  else Layer2:=stringtofloat(Soil3Grid.Cells[0,1]);
  if Soil3Grid.Cells[0,2]='' then Layer3:=-1
  else Layer3:=stringtofloat(Soil3Grid.Cells[0,2]);
  if Soil3Grid.Cells[0,3]='' then Trans:=-1
  else Trans:=stringtofloat(Soil3Grid.Cells[0,3]);
  if Soil3Grid.Cells[0,4]='' then Aquif:=-1
  else Aquif:=stringtofloat(Soil3Grid.Cells[0,4]);
  if Soil3Grid.Cells[1,0]='' then TotPor1:=-1
  else TotPor1:=stringtofloat(Soil3Grid.Cells[1,0]);
  if Soil3Grid.Cells[1,1]='' then TotPor2:=-1
  else TotPor2:=stringtofloat(Soil3Grid.Cells[1,1]);
  if Soil3Grid.Cells[1,2]='' then TotPor3:=-1
  else TotPor3:=stringtofloat(Soil3Grid.Cells[1,2]);
  if Soil3Grid.Cells[1,3]='' then TotPorTR:=-1
  else TotPorTR:=stringtofloat(Soil3Grid.Cells[1,3]);
  if Soil3Grid.Cells[1,4]='' then TotPorAQ:=-1
  else TotPorAQ:=stringtofloat(Soil3Grid.Cells[1,4]);
  if Soil3Grid.Cells[2,0]='' then EffPor1:=-1
  else EffPor1:=stringtofloat(Soil3Grid.Cells[2,0]);
  if Soil3Grid.Cells[2,1]='' then EffPor2:=-1
  else EffPor2:=stringtofloat(Soil3Grid.Cells[2,1]);
  if Soil3Grid.Cells[2,2]='' then EffPor3:=-1
  else EffPor3:=stringtofloat(Soil3Grid.Cells[2,2]);
  if Soil3Grid.Cells[2,3]='' then EffPorTR:=-1
  else EffPorTR:=stringtofloat(Soil3Grid.Cells[2,3]);
  if Soil3Grid.Cells[2,4]='' then EffPorAQ:=-1
  else EffPorAQ:=stringtofloat(Soil3Grid.Cells[2,4]);
  if Soil3Grid.Cells[3,0]='' then LeachEff1:=-1
  else LeachEff1:=stringtofloat(Soil3Grid.Cells[3,0]);
  if Soil3Grid.Cells[3,1]='' then LeachEff2:=-1
  else LeachEff2:=stringtofloat(Soil3Grid.Cells[3,1]);
  if Soil3Grid.Cells[3,2]='' then LeachEff3:=-1
  else LeachEff3:=stringtofloat(Soil3Grid.Cells[3,2]);
  if Soil3Grid.Cells[3,3]='' then LeachEffTR:=-1
  else LeachEffTR:=stringtofloat(Soil3Grid.Cells[3,3]);
  if Soil3Grid.Cells[3,4]='' then LeachEffAQ:=-1
  else LeachEffAQ:=stringtofloat(Soil3Grid.Cells[3,4]);
  if Soil3Grid.Cells[4,0]='' then InitSaltRoot1:=-1
  else InitSaltRoot1:=stringtofloat(Soil3Grid.Cells[4,0]);
  if Soil3Grid.Cells[4,1]='' then InitSaltRoot2:=-1
  else InitSaltRoot2:=stringtofloat(Soil3Grid.Cells[4,1]);
  if Soil3Grid.Cells[4,2]='' then InitSaltRoot3:=-1
  else InitSaltRoot3:=stringtofloat(Soil3Grid.Cells[4,2]);
  if Soil3Grid.Cells[4,3]='' then InitSaltTrans:=-1
  else InitSaltTrans:=stringtofloat(Soil3Grid.Cells[4,3]);
  if Soil3Grid.Cells[4,4]='' then InitSaltAquif:=-1
  else InitSaltAquif:=stringtofloat(Soil3Grid.Cells[4,4]);

  //Checking data
  if (Layer1=-1) or (TotPor1=-1) or (EffPor1=-1) then
  begin
    showmessage ('The soil data for the 1st layer are not complete.'+
                 ' Calculations cannot be done');
    Checked:=false;
    exit;
  end;
  if (Layer2=-1) or (TotPor2=-1) or (EffPor2=-1) then
  begin
    showmessage ('The soil data for the 2nd layer are not complete.'+
                 ' Calculations cannot be done');
    Checked:=false;
    exit;
  end;
  if (Layer3=-1) or (TotPor3=-1) or (EffPor3=-1) then
  begin
    showmessage ('The soil data for the 3rd layer are not complete.'+
                 ' Calculations cannot be done');
    Checked:=false;
    exit;
  end;
  if (Trans=-1) or (TotPorTR=-1) or (EffPorTR=-1) then
  begin
    showmessage ('The soil data for the transition zone are not complete.'+
                 ' Calculations cannot be done');
    exit;
  end;
  if (Aquif=-1) or (TotPorAQ=-1) or (EffPorAQ=-1) then
  begin
    showmessage ('The soil data for the aquifer are not complete.'+
                 ' Calculations cannot be done');
    Checked:=false;
    exit;
  end;

  if InputOpened then
    showmessage ('The soil data were saved.')
  else
    showmessage ('The soil data were saved.'+
                 ' Continue with the soil salinity data.');
  if InputOpened then SaveAllButton.Enabled:=true;
  RootZone:=Layer1+Layer2+Layer3;
  Soil3Panel.Visible:=false;
  if InputOpened then EnableButtons
     else DisableButtons;
  SaltOpenButton.Enabled:=true;
  Soil3QuitButton.Enabled:=true;
  Salt3Panel.Visible:=true;
  if not InputOpened then DrainQuitButton.Enabled:=false;
end;

//Salt panel 1

procedure TMainForm.Salt1QuitButtonClick(Sender: TObject);
begin
  Salt1Panel.Visible:=false;
  Soil1Panel.Visible:=false;
  if InputOpened then EnableButtons
     else DisableButtons;
end;


procedure TMainForm.SaltGrid1SetEditText(Sender: TObject; ACol,
ARow: Integer; const Value: String);
var MultiPaste:boolean;
begin
  HydrPaste:=false;
  OneLayer:=true;
  TwoLayer:=false;
  ThreeLayer:=false;
  MultiPaste := (POS(FORMAT('%s',[#9]), Value)> 0 );
  MultiPaste := MultiPaste or (POS(FORMAT('%s',[#13]), Value)> 0 );
  if MultiPaste then
  begin
    Try
      HandlePasteMultiCell(Sender, ACol, ARow, Value) ;
      Except on E: Exception do
      begin
        Showmessage ('There are not enough dat to be pasted or the data'+
                     ' are incompatible');
        exit;
      end;
    end;
  end;
end;


procedure TMainForm.Salt1SaveButtonClick(Sender: TObject);
var i : integer;
begin
  setlength (SaltRoot1M,NrOfSteps+1);
  setlength (SaltTransM,NrOfSteps+1);
  setlength (SaltAquifM,NrOfSteps+1);
  for i:=1 to NrOfSteps do
  begin
    try
      SaltRoot1M[i] := StringToFloat(SaltGrid3.Cells[1,i]);
      except on EConvertError do SaltRoot1M[i] := -1;
    end;
    try
      SaltTransM[i] := StringToFloat(SaltGrid3.Cells[4,i]);
      except on EConvertError do SaltTransM[i] := -1;
    end;
    try
      SaltAquifM[i] := StringToFloat(SaltGrid3.Cells[5,i]);
      except on EConvertError do SaltAquifM[i] := -1;
    end;
  end;
  if InputOpened then
    showmessage ('The salinity data were saved.')
  else
    showmessage ('The salinity data were saved.'+
                 ' Continue with the Drainage data..');
  Salt1Panel.Visible:=false;
  Salt1QuitButton.Enabled:=true;
  if InputOpened then EnableButtons
     else DisableButtons;
  DrainOpenButton.Enabled:=true;
  DrainPanel.Visible:=true;
end;

//Salt Panel 2

procedure TMainForm.Salt2QuitButtonClick(Sender: TObject);
begin
  Salt2Panel.Visible:=false;
  if InputOpened then EnableButtons
     else DisableButtons;
  SaltOpenButton.Enabled:=true;
end;


procedure TMainForm.SaltGrid2SetEditText(Sender: TObject; ACol,
  ARow: Integer; const Value: String);
var MultiPaste:boolean;
begin
  HydrPaste:=false;
  OneLayer:=false;
  TwoLayer:=true;
  ThreeLayer:=false;
  MultiPaste := (POS(FORMAT('%s',[#9]), Value)> 0 );
  MultiPaste := MultiPaste or (POS(FORMAT('%s',[#13]), Value)> 0 );
  if MultiPaste then
  begin
    Try
      HandlePasteMultiCell(Sender, ACol, ARow, Value) ;
      Except on E: Exception do
      begin
        Showmessage ('There are not enough data to be pasted or the data'+
                     ' are incompatible');
        exit;
      end;
    end;
  end;
end;


procedure TMainForm.Salt2SaveButtonClick(Sender: TObject);
var i : integer;
begin
  setlength (SaltRoot1M,NrOfSteps+1);
  setlength (SaltRoot2M,NrOfSteps+1);
  setlength (SaltTransM,NrOfSteps+1);
  setlength (SaltAquifM,NrOfSteps+1);
  for i:=1 to NrOfSteps do
  begin
    try
      SaltRoot1M[i] := StringToFloat(SaltGrid3.Cells[1,i]);
      except on EConvertError do SaltRoot1M[i] := -1;
    end;
    try
      SaltRoot2M[i] := StringToFloat(SaltGrid3.Cells[2,i]);
      except on EConvertError do SaltRoot2M[i] := -1;
    end;
    try
      SaltTransM[i] := StringToFloat(SaltGrid3.Cells[4,i]);
      except on EConvertError do SaltTransM[i] := -1;
    end;
    try
      SaltAquifM[i] := StringToFloat(SaltGrid3.Cells[5,i]);
      except on EConvertError do SaltAquifM[i] := -1;
    end;
  end;
  if InputOpened then
    showmessage ('The salinity data were saved.')
  else
    showmessage ('The salinity data were saved.'+
                 ' Continue with the Drainage data ..');
  Salt2Panel.Visible:=false;
  Salt2QuitButton.Enabled:=true;
  if InputOpened then EnableButtons
     else DisableButtons;
  DrainOpenButton.Enabled:=true;
  DrainPanel.Visible:=true;
end;

//Salt3 Panel

procedure TMainForm.Salt3QuitButtonClick(Sender: TObject);
begin
  Salt3Panel.Visible:=false;
  if InputOpened then EnableButtons
     else DisableButtons;
  SaltOpenButton.Enabled:=true;
end;


procedure TMainForm.SaltGrid3SetEditText(Sender: TObject; ACol,
  ARow: Integer; const Value: String);
var MultiPaste:boolean;
begin
  HydrPaste:=false;
  OneLayer:=false;
  TwoLayer:=false;
  ThreeLayer:=true;
  MultiPaste := (POS(FORMAT('%s',[#9]), Value)> 0 );
  MultiPaste := MultiPaste or (POS(FORMAT('%s',[#13]), Value)> 0 );
  if MultiPaste then
  begin
    Try
      HandlePasteMultiCell(Sender, ACol, ARow, Value) ;
      Except on E: Exception do
      begin
        Showmessage ('There are not enough dat to be pasted or the data'+
                     ' are incompatible');
        exit;
      end;
    end;
  end;
end;


procedure TMainForm.Salt3SaveButtonClick(Sender: TObject);
var i : integer;
begin
  setlength (SaltRoot1M,NrOfSteps+1);
  setlength (SaltRoot2M,NrOfSteps+1);
  setlength (SaltRoot3M,NrOfSteps+1);
  setlength (SaltTransM,NrOfSteps+1);
  setlength (SaltAquifM,NrOfSteps+1);

  for i:=1 to NrOfSteps do
  begin
    try
      SaltRoot1M[i] := StringToFloat(SaltGrid3.Cells[1,i]);
      except on EConvertError do SaltRoot1M[i] := -1;
    end;
    try
      SaltRoot2M[i] := StringToFloat(SaltGrid3.Cells[2,i]);
      except on EConvertError do SaltRoot2M[i] := -1;
    end;
    try
      SaltRoot3M[i] := StringToFloat(SaltGrid3.Cells[3,i]);
      except on EConvertError do SaltRoot3M[i] := -1;
    end;
    try
      SaltTransM[i] := StringToFloat(SaltGrid3.Cells[4,i]);
      except on EConvertError do SaltTransM[i] := -1;
    end;
    try
      SaltAquifM[i] := StringToFloat(SaltGrid3.Cells[5,i]);
      except on EConvertError do SaltAquifM[i] := -1;
    end;
  end;
  if InputOpened then
    showmessage ('The salinity data were saved.')
  else
    showmessage ('The salinity data were saved.'+
                 ' Continue with the Drainage data ..');
  Salt3Panel.Visible:=false;
  Salt3QuitButton.Enabled:=true;
  if InputOpened then EnableButtons
     else DisableButtons;
  DrainOpenButton.Enabled:=true;
  DrainPanel.Visible:=true;
end;

//Drain panel

procedure TMainForm.DrainQuitButtonClick(Sender: TObject);
begin
  DrainPanel.Visible:=false;
  if InputOpened then EnableButtons
     else DisableButtons;
  DrainOpenButton.Enabled:=true;
  DrainPresentCombo.ItemIndex:=PrevDrInd;
  DrainPresentComboChange(Sender);
  DrainForm.Hide;
end;


procedure TMainForm.DrainPresentComboChange(Sender: TObject);
begin
  if DrainPresentCombo.ItemIndex=0 then
  begin
    DrainSystem:=false;
    DrainDepthLabel.Enabled:=false;
    DrainDepthEdit.Enabled:=false;
    DrainQH1Label.Enabled:=false;
    DrainQH1Edit.Enabled:=false;
    DrainQH2Label.Enabled:=false;
    DrainQH2Edit.Enabled:=false;
  end;
  if DrainPresentCombo.ItemIndex=1 then
  begin
    DrainSystem:=true;
    DrainDepthLabel.Enabled:=true;
    DrainDepthEdit.Enabled:=true;
    DrainQH1Label.Enabled:=true;
    DrainQH1Edit.Enabled:=true;
    DrainQH2Label.Enabled:=true;
    DrainQH2Edit.Enabled:=true;
  end;
//  DrainQuitButton.Enabled:=false;
end;

procedure TMainForm.DrainSaveButtonClick(Sender: TObject);
begin
  if OneLayer then Rootzone:=Layer1;
  if TwoLayer then Rootzone:=Layer1+Layer2;
  if ThreeLayer then Rootzone:=Layer1+Layer2+Layer3;
  if DrainSystem then
  begin
    if DrainDepthEdit.Text='' then DrainDepth:=-1
    else DrainDepth:=stringtofloat(DrainDepthEdit.Text);
    if DrainQH1Edit.Text='' then DrainQH1:=0
    else DrainQH1:=stringtofloat(DrainQH1Edit.Text);
    if DrainQH2Edit.Text='' then DrainQH2:=0
    else DrainQH2:=stringtofloat(DrainQH2Edit.Text);
    if DrainDepth<0 then
    begin
      showmessage ('Then depth value is invalid. Please adjust.');
      exit;
    end;
    if DrainDepth<Rootzone then
    begin
       showmessage ('The drain depth must be greater than the total thickness'+
                    ' of the root zone. Enlarge the drain depth or'+
                    ' reduce the rootzone thickness.');
       DrainQuitButton.Enabled:=true;
       exit;
    end;
    if DrainDepth>Rootzone+Trans then
    begin
       showmessage ('The drain depth must be less than the total thickness'+
                    ' of the root zone plus transition zone. Reduce the'+
                    ' drain depth or enlarge the transition zone thickness.');
       DrainQuitButton.Enabled:=true;
       exit;
    end;
    if (DrainQH1=0) and (DrainQH2=0) then
    begin
       showmessage ('The drainage recation factors QH1 and QH2 need to be'+
                    ' given a value.');
      exit;
    end;
  end;
  if InputOpened then
    showmessage ('The data on the Subsurface Drainage System were saved.')
  else
    showmessage ('The data on the subsurface drainage system were saved.'+
                 ' Continue with the data on the Initial Conditions.');
  if InputOpened then EnableButtons
     else DisableButtons;
  DrainQuitButton.Enabled:=true;
  DrainPanel.Visible:=false;
  CondPanel.Visible:=true;
  CondOpenButton.Enabled:=true;
  PrevDrInd:=DrainPresentCombo.ItemIndex;
  DrainForm.Hide;
end;

//Boundary conditions Panel
procedure TMainForm.CondQuitButtonClick(Sender: TObject);
begin
  EnableButtons;
  if not InputOpened then SaveAllButton.Enabled:=false;
  CondPanel.Visible:=false;
end;

procedure TMainForm.CondSaveButtonClick(Sender: TObject);
var CheckValue : integer;
begin
  CheckValue:=0;
  if SaltIrrigEdit.Text='' then CheckValue:=-1
     else SaltIrrig:=stringtofloat(SaltIrrigEdit.Text);
  if WTdepthEdit.Text='' then CheckValue:=-1
     else InitDepthWT:=stringtofloat(WTdepthEdit.Text);
  if GrwtInfEdit.Text='' then CheckValue:=-1
     else GrwtInf:=stringtofloat(GrwtInfEdit.Text);
  if GrwtOutEdit.Text='' then CheckValue:=-1
     else GrwtOut:=stringtofloat(GrwtOutEdit.Text);
  if CritDepthEdit.Text='' then CheckValue:=-1
     else CritDepth:=stringtofloat(CritDepthEdit.Text);
  if IrrEffEdit.Text='' then CheckValue:=-1
     else IrrEff:=stringtofloat(IrrEffEdit.Text);
  if MoistEdit.Text='' then CheckValue:=-1
     else Moisture:=stringtofloat(MoistEdit.Text);
  if IrrEff>100 then IrrEff:=100;
  if IrrEff<30 then IrrEff:=30;
  if Moisture>100 then Moisture:=100;
  if Moisture<20 then Moisture:=20;
  if SalInfEdit.Text='' then CheckValue:=-1
     else SalInf:=stringtofloat(SalInfEdit.Text);
  if CheckValue<0 then
  begin
    showmessage ('There are invalid values. Please adjust.');
    exit
  end;
  if InputOpened then
    showmessage ('The data on the Initial Conditions were saved.')
  else
    showmessage ('The data on the initial conditions were saved.'+
                 ' Use "Save all" to do the calculations.');
  CondPanel.Visible:=false;
  EnableButtons;
  CondQuitButton.Enabled:=true;
  InputOpened:=true;
end;


procedure TMainForm.DrainHelpButtonClick(Sender: TObject);
begin
  DrainForm.Show;
end;

//Output

procedure TMainForm.SaltShowButtonClick(Sender: TObject);
begin
  OutGrid.Visible:=false;
  SaltShowButton.Enabled:=false;
  HydrShowButton.Enabled:=true;
  WriteSaltTable;
  OutGrid.Visible:=true;
  CopyLabel.Visible:=true;
end;


procedure TMainForm.HydrShowButtonClick(Sender: TObject);
begin
  ReadOutData;
  OutGrid.Visible:=false;
  HydrShowButton.Enabled:=false;
  SaltShowButton.Enabled:=true;
  WriteHydrTable;
  OutGrid.Visible:=true;
  CopyLabel.Visible:=true;
end;


procedure TMainForm.ClipButtonClick(Sender: TObject);
const
  TAB = #9;
  CR = #13;
var
  R, C: integer;
  S: string;
begin
  S := '';
  for R := 0 to OutGrid.RowCount - 1 do begin
    for C := 0 to OutGrid.ColCount - 1 do begin
      S := S + OutGrid.Cells[C, R];
      if C < OutGrid.ColCount - 1 then S := S + TAB;
    end;
    if R < OutGrid.RowCount - 1 then S := S + CR;
  end;
  Clipboard.AsText := S;
  showmessage ('The data are on the clipboard to be pasted elsewhere.');
end;


procedure TMainForm.OpenOutputButtonClick(Sender: TObject);
var NewDir : string;
begin
  if OutputOpenDialog.Execute then
  begin
    OutFileName := OutputOpenDialog.Files.Strings[0];
    NewDir := ExtractFilePath(FileName);
    InputOpenDialog.InitialDir:=NewDir;
    InputSaveDialog.InitialDir:=NewDir;
    OutputOpenDialog.InitialDir:=NewDir;
    ReadOutData;
  end else
  begin
    ShowMessage('No output file was selected');
    exit;
  end;
  InFileName := changefileext(OutFileName,'.inp');
  ReadInpData;
  OutputMemo.Visible:=false;
  WriteOutput;
  GraphButton.Enabled:=true;
  OutputMemo.Visible:=true;
  OutLabel.Visible:=true;
  SaltShowButton.Visible:=true;
  HydrShowButton.Visible:=true;
  SaltShowButton.Enabled:=true;
  HydrShowButton.Enabled:=true;
  GraphImage.Visible:=false;
  GraphPanel.Visible:=false;
  GraphSelectButton.Enabled:=false;
  SaveGraphButton.Enabled:=false;
  OutSalt1Memo.Visible:=false;
  OutSalt2Memo.Visible:=false;
  OutSalt3Memo.Visible:=false;
  HydrOutMemo.Visible:=false;
  OutGrid.Visible:=false;
  CopyLabel.Visible:=false;
  CalcDone:=false;
  ClipLabel.Visible:=false;
  ClipButton.Visible:=false;
end;

//Graphics

procedure TMainForm.GraphButtonClick(Sender: TObject);
begin
  MainForm.GraphPanel.Visible:=true;
  MainForm.GraphImage.Visible:=false;
  SaveGraphButton.Enabled:=false;
  GraphSelectButton.Enabled:=false;
  SalSecondRadioButton.Enabled:=true;
  SalThirdRadioButton.Enabled:=true;
  if OneLayer then
  begin
    SalSecondRadioButton.Enabled:=false;
    SalThirdRadioButton.Enabled:=false;
    SalSecondRadioButton.Checked:=false;
    SalThirdRadioButton.Checked:=false;
  end;
  if TwoLayer then
  begin
    SalThirdRadioButton.Enabled:=false;
    SalThirdRadioButton.Checked:=false;
  end;
  GraphTab.Show;
end;


procedure TMainForm.MakeGraphButtonClick(Sender: TObject);
begin
  showmessage ('To make a graph, an output file must be opened first.');
  OpenOutputButtonClick(Sender);
  GraphImage.Visible:=false;
  GraphSelectButton.Enabled:=false;
  SaveGraphButton.Enabled:=false;
  GraphPanel.Visible:=true;
  GraphTab.Show;
end;


procedure TMainForm.GraphGoButtonClick(Sender: TObject);
begin
  SaveGraphButton.Enabled:=true;
  GraphSelectButton.Enabled:=true;
  NoExclusion:=true;
  ExclSubSurf:=false;
  ExclSurf:=false;
  ExclSalFirst:=false;
  ExclSalSecond:=false;
  ExclSalThird:=false;
  ExclSalBelow:=false;
  IncludeAll:=false;
  ReadOutData;
  if GraphHydrRadioButton.Checked then ShowHydrGraph;
  if GraphWTRadioButton.Checked then ShowWTGraph;
  if GraphSaltRadioButton.Checked then
  begin
    if NrOfLayers>1 then
    begin
      ExclSalBelow:=true;
      IncludeAll:=true;
      NoExclusion:=false;
    end;
    ShowSaltGraph;
  end;
  if SurfHydrRadioButton.Checked then
  begin
     ExclSubSurf:=true;
     ShowHydrGraph;
  end;
  if SubSurfHydrRadioButton.Checked then
  begin
    ExclSurf:=true;
    ShowHydrGraph;
  end;
  FirstLayer:=false;
  if SalFirstRadioButton.Checked then
  begin
    FirstLayer:=true;
    NoExclusion:=false;
    ExclSalSecond:=true;
    ExclSalThird:=true;
    ExclSalBelow:=true;
    ShowSaltGraph
  end;
  ScndLayer:=false;
  if SalSecondRadioButton.Checked then
  begin
    ScndLayer:=true;
    NoExclusion:=false;
    ExclSalFirst:=true;
    ExclSalThird:=true;
    ExclSalBelow:=true;
    ShowSaltGraph;
  end;
  ThirdLayer:=false;
  if SalThirdRadioButton.Checked then
  begin
    ThirdLayer:=true;
    NoExclusion:=false;
    ExclSalFirst:=true;
    ExclSalSecond:=true;
    ExclSalBelow:=true;
    ShowSaltGraph;
  end;
  if SalBelowRadioButton.Checked then
  begin
    NoExclusion:=false;
    ExclSalFirst:=true;
    ExclSalSecond:=true;
    ExclSalThird:=true;
    ShowSaltGraph;
  end;
end;



procedure TMainForm.ShowHydrGraph;
var i, ii    : integer;
    myRect   : TRect;
    DumReal  : real;
    NameStr  : string;
begin
  GraphPanel.Visible:=false;
  FindHydrMax;
  HydrRelative;

  with GraphImage.Canvas do
  begin
    Font.Size := 10;
    Font.Color := clBlack;
    Font.Name := 'Arial';
    Brush.Color:=clSilver;
    myRect:= Rect(0,0,623,460);
    FillRect (myRect);
    Textout (20,5,Title1);
    Font.Size := 8;
    TextOut (20,PosY2+75,'Program LeachMod at www.waterlog.info');
    Brush.Color := $8B0000;
    myRect:= Rect(20,19,605,420);
    FillRect (myRect);
    Pen.Style := psSolid;
    Pen.Color := clwhite;        {for the lines}
    Pen.Width := 1;

    Font.Color := clWhite;
    Textout (516,PosY2+25,'Time step');
    TextOut (PosX1+200,20,'Hydrologic flow factors (mm / time step)');
    if not ExclSurf then
    begin
      TextOut (PosX1+10,30,'- - - Rainfall');
      Font.Color := clYellow;
      TextOut (PosX1+10,45,'- - - Irrigation');
      Font.Color := clLime;
      TextOut (PosX1+10,60,'- - - Evaporation');
      Font.Color := clskyblue;
      TextOut (PosX1+10,75,'- - - Surf. drainage');
    end;
    if not ExclSubSurf then
    begin
      if not ExclSurf then
      begin
        Font.Color := clAqua;
        TextOut (PosX1+10,90,'- - - Percolation');
        Font.Color := clred;
        TextOut (PosX1+10,105,'- - - Capillary rise');
        Font.Color := $05BA7D7;                {light brown}
        TextOut (PosX1+10,120,'- - - Subs. drainage');
      end else
      begin
        Font.Color := clAqua;
        TextOut (PosX1+10,30,'- - - Percolation');
        Font.Color := clred;
        TextOut (PosX1+10,45,'- - - Capillary rise');
        Font.Color := $05BA7D7;                {light brown}
        TextOut (PosX1+10,60,'- - - Subs. drainage');
      end;
    end;
    Font.Color := clWhite;
    Pen.Width:=1;
    if not ExclSurf then
    begin
      for i:=1 to NrOfSteps-1 do
      begin
        Pen.Color:=clWhite;
        moveto (RelXdata[i]-2,RelRain[i]);
        lineto (RelXdata[i+1]-2,RelRain[i]);
        if i<NrOfSteps-1 then
        begin
          moveto (RelXdata[i+1]-2,RelRain[i]);
          lineto (RelXdata[i+1]-2,RelRain[i+1]);
        end;
      end;
      for i:=1 to NrOfSteps-1 do
      begin
        Pen.Color:=clYellow;
        moveto (RelXdata[i]+2,RelIrri[i]);
        lineto (RelXdata[i+1]+2,RelIrri[i]);
        if i<NrOfSteps-1 then
        begin
          moveto (RelXdata[i+1]+2,RelIrri[i]);
          lineto (RelXdata[i+1]+2,RelIrri[i+1]);
        end;
      end;
      for i:=1 to NrOfSteps-1 do
      begin
        Pen.Color:=clLime;
        moveto (RelXdata[i],RelEvap[i]);
        lineto (RelXdata[i+1],RelEvap[i]);
        if i<NrOfSteps-1 then
        begin
          moveto (RelXdata[i+1],RelEvap[i]);
          lineto (RelXdata[i+1],RelEvap[i+1]);
        end;
      end;
    end;
    if not ExclSubSurf then
    begin
      for i:=1 to NrOfSteps-1 do
      begin
        Pen.Color:=clAqua;
        moveto (RelXdata[i]+1,RelPerc[i]);
        lineto (RelXdata[i+1]+1,RelPerc[i]);
        if i<NrOfSteps-1 then
        begin
          moveto (RelXdata[i+1]+1,RelPerc[i]);
          lineto (RelXdata[i+1]+1,RelPerc[i+1]);
        end;
      end;
      for i:=1 to NrOfSteps-1 do
      begin
//        Pen.Color:=$00F593FD;
        Pen.Color:=clred;
        moveto (RelXdata[i]+2,RelCap[i]);
        lineto (RelXdata[i+1]+2,RelCap[i]);
        if i<NrOfSteps-1 then
        begin
          moveto (RelXdata[i+1]+2,RelCap[i]);
          lineto (RelXdata[i+1]+2,RelCap[i+1]);
        end;
      end;
      for i:=1 to NrOfSteps-1 do
      begin
        Pen.Color:=$05BA7D7;
        moveto (RelXdata[i]+3,RelDrc[i]);
        lineto (RelXdata[i+1]+3,RelDrc[i]);
        if i<NrOfSteps-1 then
        begin
          moveto (RelXdata[i+1]+3,RelDrc[i]);
          lineto (RelXdata[i+1]+3,RelDrc[i+1]);
        end;
      end;
    end;

    Pen.Color := clwhite;                            {for the lines}
    Font.Color := clWhite;
    moveto (PosX1,PosY2);                            { vertical axis }
    lineto (PosX1,PosY1);
    for ii:=0 to ScaleY do
    begin
      Moveto (posX1,round(posY1+(ii/ScaleY)*LY));
      Lineto (posX1-4, round(posY1+(ii/ScaleY)*LY));
      DumReal := ii/ScaleY*(MaxY-MinY);
      NameStr := format('%' + IntToStr(2 + decimY) + '.' +
                 IntToStr(decimY) + 'f', [MaxY - DumReal]);
                      {bijv. '%3.1f' voor 1 decimaal, 3 cijfers, float number}
      Textout ((posX1-TextWidth(NameStr)-6),
              (round(posY1+(ii/ScaleY)*LY)-round(1/2*TextHeight(NameStr))),
               NameStr);
    end;

    moveto (PosX1,PosY2);                           { horizontal axis }
    lineto (PosX2,PosY2);
    for ii:=0 to ScaleX do
    begin Moveto(round(posX1+(ii/ScaleX)*LX), posY2);
          Lineto(round(posX1+(ii/ScaleX)*LX), PosY2+4);
          DumReal := ii*(MaxX-MinX)/ScaleX;
          NameStr := format('%' + IntToStr(2 + decimX) + '.' +
                     IntToStr(decimX) + 'f', [MinX+DumReal]);
          Textout (round(posX1-8+(ii/ScaleX)*LX), PosY2+12, NameStr);
    end;

  end; { with GraphImage.Canvas do}
  GraphImage.Visible:=true;
end; {procedure TMainForm.ShowHydrGraph}



procedure TMainForm.ShowWTGraph;
var i, ii, PosY3    : integer;
    myRect   : TRect;
    DumReal  : real;
    NameStr  : string;
begin
  GraphPanel.Visible:=false;
  FindWTMaxMin;
  WTRelative;

  with GraphImage.Canvas do
  begin
    Font.Size := 10;
    Font.Color := clBlack;
    Font.Name := 'Arial';
    Brush.Color:=clSilver;
    myRect:= Rect(0,0,623,460);
    FillRect (myRect);
    Textout (20,5,Title1);
    Font.Size := 8;
    TextOut (20,PosY2+75,'Program LeachMod at www.waterlog.info');
//    Brush.Color := clblue;
    Brush.Color := $8B0000;
    myRect:= Rect(20,19,605,420);
    FillRect (myRect);
    Pen.Style := psSolid;
    Pen.Color := clwhite;        {for the lines}
    Pen.Width := 1;

    Font.Color := clWhite;
    Textout (516,PosY2+25,'Time step');
    TextOut (PosX1+10,30,' Level of water table relative to soil surface');
    Brush.Color:=clSilver;

    if WTMax>=0 THEN
    BEGIN
      PosY3:=PosY2+(PosY2-PosY1)*MinY div (MaxY-MinY);
      for i:=1 to NrOfSteps-1 do
      begin
        if DepthWT[i]>0 then
        begin
        if Brush.Color=clInactiveCaption then Brush.Color:=clSkyBlue
        else Brush.Color:=clInactiveCaption;
        if RelWT[i+1]<PosY1 then
           Fillrect (Rect(RelXdata[i],PosY3,RelXdata[i+1],RelWT[i+1]))
        else
           Fillrect (Rect(RelXdata[i],RelWT[i],RelXdata[i+1],PosY3));
        end else
        begin
        if Brush.Color=clInactiveCaption then Brush.Color:=clSkyBlue
        else Brush.Color:=clInactiveCaption;
        if RelWT[i+1]<PosY1 then
           Fillrect (Rect(RelXdata[i],PosY3,RelXdata[i+1],RelWT[i+1]))
        else
           Fillrect (Rect(RelXdata[i],RelWT[i],RelXdata[i+1],PosY3));
        end;
      end;
    END;

    if WTMax<0 THEN
    BEGIN
      for i:=1 to NrOfSteps-1 do
      begin
        if Brush.Color=clInactiveCaption then Brush.Color:=clSkyBlue
        else Brush.Color:=clInactiveCaption;
        if RelWT[i+1]<PosY1 then
           Fillrect (Rect(RelXdata[i],PosY1,RelXdata[i+1],RelWT[i+1]))
        else
           Fillrect (Rect(RelXdata[i],RelWT[i],RelXdata[i+1],PosY1));
      end;
    END;
    Brush.Color := $8B0000;

    Pen.Color := clwhite;                            {for the lines}
    Font.Color := clWhite;
    moveto (PosX1,PosY2);                            { vertical axis }
    lineto (PosX1,PosY1);
    for ii:=0 to ScaleY do
    begin
      Moveto (posX1,round(posY1+(ii/ScaleY)*LY));
      Lineto (posX1-4, round(posY1+(ii/ScaleY)*LY));
      DumReal := ii/ScaleY*(MaxY-MinY);
      NameStr := format('%' + IntToStr(2 + decimY) + '.' +
                 IntToStr(decimY) + 'f', [MaxY - DumReal]);
                      {bijv. '%3.1f' voor 1 decimaal, 3 cijfers, float numbr}
      Textout ((posX1-TextWidth(NameStr)-6),
              (round(posY1+(ii/ScaleY)*LY)-round(1/2*TextHeight(NameStr))),
               NameStr);
    end;

    moveto (PosX1,PosY2);                           { horizontal axis }
    lineto (PosX2,PosY2);
    for ii:=0 to ScaleX do
    begin Moveto(round(posX1+(ii/ScaleX)*LX), posY2);
          Lineto(round(posX1+(ii/ScaleX)*LX), PosY2+4);
          DumReal := ii*(MaxX-MinX)/ScaleX;
          NameStr := format('%' + IntToStr(2 + decimX) + '.' +
                     IntToStr(decimX) + 'f', [MinX+DumReal]);
          Textout (round(posX1-8+(ii/ScaleX)*LX), PosY2+12, NameStr);
    end;

  end; { with GraphImage.Canvas do}
  GraphImage.Visible:=true;
end; {procedure TMainForm.ShowWTGraph}



procedure TMainForm.ShowSaltGraph;
var i, ii    : integer;
    myRect   : TRect;
    DumReal  : real;
    NameStr, Leaching  : string;
begin
  GraphPanel.Visible:=false;
  FindSaltMaxMin;
  if NoExclusion then
  begin
    Ymax:=1.2*Ymax;
    MaxY:=round(Ymax);
  end;
  SaltRelative;

  with GraphImage.Canvas do
  begin
    Font.Size := 10;
    Font.Color := clBlack;
    Font.Name := 'Arial';
    Brush.Color:=clSilver;
    myRect:= Rect(0,0,623,460);
    FillRect (myRect);
    Textout (20,5,Title1);
    Font.Size := 8;
    TextOut (20,PosY2+75,'Program LeachMod at www.waterlog.info');
    Brush.Color := $8B0000;
    myRect:= Rect(20,19,605,420);
    FillRect (myRect);
    Pen.Style := psSolid;
    Pen.Color := clwhite;        {for the lines}
    Pen.Width := 1;

    Font.Color := clSilver;
    TextOut (PosX1,20,Title2);
    Font.Color := clWhite;
    TextOut (516,PosY2+25,'Time step');
    Font.Color := clWhite;
    TextOut (PosX1+10,40,'Soil moisture salinity (ECsm in dS / m)');
    if (NrOfLayers>0) and not ExclSalFirst then
    begin
      Font.Color := clSilver;
      TextOut (PosX1+10,60,'- - - Layer l calculated');
      TextOut (PosX1+10,75,'  x   Layer 1 measured');
      Leaching:=format('%6.2f',[LEff1]);
      if not GraphSaltRadioButton.Checked then
      begin
        Font.Color := clwhite;
        if not NoCount1 and Optim1 and ExclSalBelow then
        begin
          TextOut (PosX1+320,25,'Leaching efficiency : '+Leaching+
                   ' (optimized)');
          NameStr:=format('%5.0f',[Expl1]);
          TextOut (PosX1+320,40,'Model fit index (%)  : '+NameStr);
        end;
        if not NoCount1 and not Optim1 and ExclSalBelow then
        begin
          TextOut (PosX1+320,25,'Leaching efficiency : '+Leaching+
                   ' (assumed)');
          NameStr:=format('%5.0f',[Expl1]);
          TextOut (PosX1+320,40,'Model fit index (%)  : '+NameStr);
        end;
        if NoCount1 then
        begin
          TextOut (PosX1+320,25,'Leaching efficiency : '+Leaching+
                   ' (assumed)');
          TextOut (PosX1+320,40,'Model fit index (%)  : n.a.');
        end;
      end;
    end;
    if (NrOfLayers>1) and not ExclSalSecond then
    begin
      if ExclSalFirst then
      begin
        Font.Color := clyellow;
        TextOut (PosX1+10,60,'- - - Layer 2 calculated');
        TextOut (PosX1+10,75,'  o   Layer 2 measured');
      end else
      begin
        Font.Color := clwhite;
        TextOut (PosX1+10,90,'- - - Layer 2 calculated');
        TextOut (PosX1+10,105,'  o   Layer 2 measured');
      end;
      if not GraphSaltRadioButton.Checked then
      begin
        Leaching:=format('%6.2f',[LEff2]);
        if not NoCount2 and Optim2 and ExclSalBelow then
        begin
          TextOut (PosX1+320,25,'Leaching efficiency : '+Leaching+
                   ' (optimized)');
          NameStr:=format('%5.0f',[Expl2]);
          TextOut (PosX1+320,40,'Model fit index (%)  : '+NameStr);
        end;
        if not NoCount2 and not Optim2 and ExclSalBelow then
        begin
          TextOut (PosX1+320,25,'Leaching efficiency : '+Leaching+
                   ' (assumed)');
          NameStr:=format('%5.0f',[Expl2]);
          TextOut (PosX1+320,40,'Model fit index (%)  : '+NameStr);
        end;
        if NoCount2 then
        begin
          TextOut (PosX1+320,25,'Leaching efficiency : '+Leaching+
                   ' (assumed)');
          TextOut (PosX1+320,40,'Model fit index (%)  : n.a.');
        end;
       end;
    end;
    if (NrOfLayers>2) and not ExclSalThird then
    begin
//      Font.Color := $00baf2b7;
      Font.Color := cllime;
      if ExclSalFirst and ExclSalSecond then
      begin
        TextOut (PosX1+10,60,'- - - Layer 3 calculated');
        TextOut (PosX1+10,75,'  s   Layer 3 measured');
      end else
      begin
        TextOut (PosX1+10,120,'- - - Layer 3 calculated');
        TextOut (PosX1+10,135,'  s   Layer 3 measured');
      end;
      if not GraphSaltRadioButton.Checked then
      begin
         Leaching:=format('%6.2f',[LEff3]);
        if not NoCount3 and Optim3 and ExclSalBelow then
        begin
          TextOut (PosX1+320,25,'Leaching efficiency : '+Leaching+
                   ' (optimized)');
          NameStr:=format('%5.0f',[Expl3]);
          TextOut (PosX1+320,40,'Model fit index (%)  : '+NameStr);
        end;
        if not NoCount3 and not Optim3 and ExclSalBelow then
        begin
          TextOut (PosX1+320,25,'Leaching efficiency : '+Leaching+
                   ' (assumed)');
          NameStr:=format('%5.0f',[Expl3]);
          TextOut (PosX1+320,40,'Model fit index (%)  : '+NameStr);
        end;
        if NoCount3 then
        begin
          TextOut (PosX1+320,25,'Leaching efficiency : '+Leaching+
                   ' (assumed)');
          TextOut (PosX1+320,40,'Model fit index (%)  : n.a.');
        end;
     end;
    end;
    if not ExclSalBelow then
    begin
        Font.Color:=clAqua;
        TextOut (PosX1+300,25,'- - - Transition zone calculated');
        Font.Color:=clAqua;
        TextOut (PosX1+300,40,'  z   Transition zone measured');
        Font.Color:=$00ccd2f9;
        TextOut (PosX1+300,55,'- - - Aquifer calculated');
        TextOut (PosX1+300,70,'  v   Aquifer measured');
        if not NoCount4 and Optim4 then
        begin
          NameStr:=floattostr(LEff4);
          Font.Color:=clAqua;
          TextOut (PosX1+10,60,  ' Leaching efficiency (optimized)  = '+NameStr);
          NameStr:=floattostr(ExplTR);
          TextOut (PosX1+10,75, ' Coefficient of determination (%) = '+NameStr);
        end;
        if not NoCount5 and Optim5 then 
        begin
          NameStr:=floattostr(LEff5);
          Font.Color:=$00ccd2f9;
          TextOut (PosX1+10,90,  ' Leaching efficiency (optimized)  = '+NameStr);
          NameStr:=floattostr(ExplTR);
          TextOut (PosX1+10,105, ' Coefficient of determination (%) = '+NameStr);
        end;

    end;

    Font.Color := clWhite;
    Font.Size:=10;
    Pen.Width:=1;
    if (NrOfLayers>0) and not ExclSalFirst then
    for i:=1 to NrOfSteps-1 do
    begin
      Pen.Color:=clSilver;
      moveto (RelXdata[i],RelSalt1[i]);
      lineto (RelXdata[i+1],RelSalt1[i+1]);
    end;
    if (NrOflayers>1) and not ExclSalSecond then
    for i:=1 to NrOfSteps-1 do
    begin
      Pen.Color := clwhite;
      moveto (RelXdata[i],RelSalt2[i]);
      lineto (RelXdata[i+1],RelSalt2[i+1]);
    end;
    if (NrOfLayers>2) and not ExclSalThird then
    for i:=1 to NrOfSteps-1 do
    begin
//      Pen.Color := $00baf2b7;
      Pen.Color := cllime;
      moveto (RelXdata[i],RelSalt3[i]);
      lineto (RelXdata[i+1],RelSalt3[i+1]);
    end;
    if not ExclSalBelow then for i:=1 to NrOfSteps-1 do
    begin
      Pen.Color:=clAqua;
      moveto (RelXdata[i],RelSaltTR[i]);
      lineto (RelXdata[i+1],RelSaltTR[i+1]);
        Pen.Color:=$00ccd2f9;
      moveto (RelXdata[i],RelSaltAQ[i]);
      lineto (RelXdata[i+1],RelSaltAQ[i+1]);
    end;
    if (NrOfLayers>0) and not ExclSalFirst then
    for i:=1 to NrOfSteps do if  (SaltRoot1M[i]>0) then
    begin
      Font.Color:=clWhite;
      TextOut (RelXdata[i]-7,RelSalt1M[i],'x');
    end;
    if (NrOfLayers>1) and not ExclSalSecond then
    for i:=1 to NrOfSteps do if (SaltRoot2M[i]>0) then
    begin
      Font.Color := $0004F0F7;
      TextOut (RelXdata[i],RelSalt2M[i],'o');
    end;
    if (NrOfLayers>2) and not ExclSalThird  then
    for i:=1 to NrOfSteps do if (SaltRoot3M[i]>0) then
    begin
      Font.Color := $00baf2b7;
      TextOut (RelXdata[i]+7,RelSalt3M[i]+2,'s');
    end;
    if not ExclSalBelow  then
    for i:=1 to NrOfSteps do if (SaltTransM[i]>0) then
    begin
      Font.Color:=clAqua;
      TextOut (RelXdata[i]+12,RelSaltTrM[i]-2,'z');
    end;
    if not ExclSalBelow  then
    for i:=1 to NrOfSteps do if (SaltAquifM[i]>0) then
    begin
      Font.Color := $00baf2b7;
      TextOut (RelXdata[i]+12,RelSaltAqM[i]-2,'v');
    end;

    Font.Color := clWhite;
    Pen.Color:=clWhite;
    Font.Size:=8;
    moveto (PosX1,PosY2);                            { vertical axis }
    lineto (PosX1,PosY1);
    for ii:=0 to ScaleY do
    begin
      Moveto (posX1,round(posY1+(ii/ScaleY)*LY));
      Lineto (posX1-4, round(posY1+(ii/ScaleY)*LY));
      DumReal := ii/ScaleY*(MaxY-MinY);
      NameStr := format('%' + IntToStr(2 + decimY) + '.' +
                 IntToStr(decimY) + 'f', [MaxY - DumReal]);
                      {bijv. '%3.1f' voor 1 decimaal, 3 cijfers, float number}
      Textout ((posX1-TextWidth(NameStr)-6),
              (round(posY1+(ii/ScaleY)*LY)-round(1/2*TextHeight(NameStr))),
               NameStr);
    end;

    moveto (PosX1,PosY2);                           { horizontal axis }
    lineto (PosX2,PosY2);
    for ii:=0 to ScaleX do
    begin Moveto(round(posX1+(ii/ScaleX)*LX), posY2);
          Lineto(round(posX1+(ii/ScaleX)*LX), PosY2+4);
          DumReal := ii*(MaxX-MinX)/ScaleX;
          NameStr := format('%' + IntToStr(2 + decimX) + '.' +
                     IntToStr(decimX) + 'f', [MinX+DumReal]);
          Textout (round(posX1-8+(ii/ScaleX)*LX), PosY2+12, NameStr);
    end;

  end; { with GraphImage.Canvas do}
  GraphImage.Visible:=true;
end; {procedure TMainForm.ShowSaltGraph}



procedure TMainForm.SaveGraphButtonClick(Sender: TObject);
var FigureFile : string;
begin
  Result:=true;
  if GraphSave_Dialog.Execute then
  begin
    FigureFile := GraphSave_Dialog.Files.Strings[0];
    if FileExists(FigureFile) then
        Result := Question('The graph already exists, overwrite?')
    else Result := true;
    if Result then
    begin
      GraphImage.Picture.SaveToFile(FigureFile);
      Showmessage ('The graph was saved as  ' + FigureFile);
    end;
  end
  else Showmessage ('The graph was not saved');
end;


procedure TMainForm.OpenGrapButtonClick(Sender: TObject);
var FigureFile : string;
begin
  inherited;
      if MainForm.GraphOpen_Dialog.Execute then
      begin
        FigureFile := MainForm.GraphOpen_Dialog.Files.Strings[0];
        if FileExists (FigureFile) then
          GraphImage.Picture.LoadFromFile(FigureFile)
        else
        begin
          Showmessage ('Picture file does not exist,'+
                       ' please select another one.');
          exit;
        end;
      end
      else
      begin
        Showmessage('No graphics file was selected');
        exit;
      end;
end; {TMainForm.OpenGrapButtonClick}
{----------------------------------}


procedure TMainForm.GraphSelectButtonClick(Sender: TObject);
begin
  GraphPanel.Visible:=true;
  GraphImage.Visible:=false;
  GraphSelectButton.Enabled:=false;
  SaveGraphButton.Enabled:=false;
end;

//Finish

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  inherited;
  Action := caNone;
  CloseForm.Show;
end;

end.
